SystemOrganization addCategory: #'Balloon3D-Plugins'!
SystemOrganization addCategory: #'Balloon3D-Plugins-Simulator'!

InterpreterPlugin subclass: #B3DEnginePlugin
	instanceVariableNames: 'loadBBFn copyBitsFn bbPluginName'
	classVariableNames: ''
	poolDictionaries: 'B3DEngineConstants'
	category: 'Balloon3D-Plugins'!

!B3DEnginePlugin commentStamp: '<historical>' prior: 0!
I am a generic superclass for all Balloon 3D plugins.!

B3DEnginePlugin subclass: #B3DClipperPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins'!

!B3DClipperPlugin methodsFor: 'primitives' stamp: 'ar 11/20/2000 22:47'!
b3dClipPolygon
	"Primitive. Clip the polygon given in the vertexArray using the temporary vertex array which is assumed to have sufficient size."
	| outMask vtxCount vtxArray tempVtxArray count |
	self export: true.
	self inline: false.
	self var: #vtxArray declareC:'int *vtxArray'.
	self var: #tempVtxArray declareC:'int *tempVtxArray'.
	interpreterProxy methodArgumentCount = 4
		ifFalse:[^interpreterProxy primitiveFail].
	outMask := interpreterProxy stackIntegerValue: 0.
	vtxCount := interpreterProxy stackIntegerValue: 2.
	vtxArray := self stackPrimitiveVertexArray: 3 ofSize: vtxCount + 4.
	tempVtxArray := self stackPrimitiveVertexArray: 1 ofSize: vtxCount + 4.
	(vtxArray == nil or:[tempVtxArray == nil or:[interpreterProxy failed]])
		ifTrue:[^interpreterProxy primitiveFail].
	"Hack pointers for one-based indexes"
	vtxArray := vtxArray - PrimVertexSize.
	tempVtxArray := tempVtxArray - PrimVertexSize.
	count := self clipPolygon: vtxArray count: vtxCount with: tempVtxArray mask: outMask.
	interpreterProxy pop: 5.
	interpreterProxy pushInteger: count.! !

!B3DClipperPlugin methodsFor: 'primitives' stamp: 'ar 4/16/1999 01:54'!
b3dDetermineClipFlags
	"Primitive. Determine the clipping flags for all vertices."
	| vtxCount vtxArray result |
	self export: true.
	self inline: false.
	self var: #vtxArray declareC:'void *vtxArray'.
	interpreterProxy methodArgumentCount = 2
		ifFalse:[^interpreterProxy primitiveFail].
	vtxCount := interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	vtxArray := self stackPrimitiveVertexArray: 1 ofSize: vtxCount.
	(vtxArray == nil or:[interpreterProxy failed])
		ifTrue:[^interpreterProxy primitiveFail].
	result := self determineClipFlags: vtxArray count: vtxCount.
	interpreterProxy failed ifFalse:[
		interpreterProxy pop: 3.
		interpreterProxy pushInteger: result.
	].! !

!B3DClipperPlugin methodsFor: 'primitives' stamp: 'ar 4/20/2001 04:06'!
b3dMapVertexBuffer
	"Primitive. Determine the bounds for all vertices in the vertex buffer."
	| vtxCount vtxArray boxArray |
	self export: true.
	self inline: false.
	self var: #vtxArray declareC:'void *vtxArray'.
	interpreterProxy methodArgumentCount = 3
		ifFalse:[^interpreterProxy primitiveFail].
	boxArray := interpreterProxy stackObjectValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	((interpreterProxy fetchClassOf: boxArray) = interpreterProxy classArray
		and:[(interpreterProxy slotSizeOf: boxArray) = 4])
			ifFalse:[^interpreterProxy primitiveFail].
	vtxCount := interpreterProxy stackIntegerValue: 1.
	interpreterProxy failed ifTrue:[^nil].
	vtxArray := self stackPrimitiveVertexArray: 2 ofSize: vtxCount.
	(vtxArray == nil or:[interpreterProxy failed])
		ifTrue:[^interpreterProxy primitiveFail].
	self mapVB: vtxArray ofSize: vtxCount into: boxArray.
	interpreterProxy failed ifFalse:[
		interpreterProxy pop: 3. "pop args; return rcvr"
	].! !

!B3DClipperPlugin methodsFor: 'primitives' stamp: 'ar 4/18/1999 02:59'!
b3dPrimitiveNextClippedTriangle
	"Primitive. Return the next clipped triangle from the vertex buffer and return its index."
	| idxCount vtxCount firstIndex vtxArray idxArray idx1 idx2 idx3 triMask |
	self export: true.
	self inline: false.
	self var: #idxArray declareC:'int *idxArray'.
	self var: #vtxArray declareC:'int *vtxArray'.
	interpreterProxy methodArgumentCount = 5
		ifFalse:[^interpreterProxy primitiveFail].
	idxCount := interpreterProxy stackIntegerValue: 0.
	vtxCount := interpreterProxy stackIntegerValue: 2.
	firstIndex := interpreterProxy stackIntegerValue: 4.
	interpreterProxy failed ifTrue:[^nil].
	vtxArray := self stackPrimitiveVertexArray: 3 ofSize: vtxCount.
	idxArray := self stackPrimitiveIndexArray: 1 ofSize: idxCount validate: true forVertexSize: vtxCount.
	(vtxArray == nil or:[idxArray == nil or:[interpreterProxy failed]])
		ifTrue:[^interpreterProxy primitiveFail].

	"Hack idxArray and vtxArray for 1-based indexes"
	idxArray := idxArray - 1.
	vtxArray := vtxArray - PrimVertexSize.
	firstIndex to: idxCount by: 3 do:[:i|
		idx1 := idxArray at: i.
		idx2 := idxArray at: i+1.
		idx3 := idxArray at: i+2.
		(idx1 == 0 or:[idx2 == 0 or:[idx3 == 0]]) ifFalse:[
			triMask := ((vtxArray at: idx1 * PrimVertexSize + PrimVtxClipFlags) bitAnd:
						((vtxArray at: idx2 * PrimVertexSize + PrimVtxClipFlags) bitAnd:
						(vtxArray at: idx3 * PrimVertexSize + PrimVtxClipFlags))).
			"Check if tri is completely inside"
			(InAllMask bitAnd: triMask) = InAllMask ifFalse:[
				"Tri is not completely inside -> needs clipping."
				(triMask anyMask: OutAllMask) ifTrue:[
					"tri is completely outside. Store all zeros"
					idxArray at: i put: 0.
					idxArray at: i+1 put: 0.
					idxArray at: i+2 put: 0.
				] ifFalse:[
					"tri must be partially clipped."
					interpreterProxy pop: 6. "args + rcvr"
					interpreterProxy pushInteger: i.
					^nil
				].
			].
		].
	].
	"No more entries"
	interpreterProxy pop: 6. "args + rcvr"
	interpreterProxy pushInteger: 0.
! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/16/1999 01:56'!
backClipValueFrom: last to: next
	self returnTypeC:'double'.
	^(((self cCoerce: last to: 'float *') at: PrimVtxRasterPosZ) - 
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosW)) /

	(
	(((self cCoerce: next to:'float *') at: PrimVtxRasterPosW) -
		((self cCoerce: last to: 'float *') at: PrimVtxRasterPosW))
	-
	 (((self cCoerce: next to:'float *') at: PrimVtxRasterPosZ) -
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosZ))
	).! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/16/1999 06:43'!
bottomClipValueFrom: last to: next
	self returnTypeC:'double'.
	^(0.0 - (((self cCoerce: last to: 'float *') at: PrimVtxRasterPosY) + 
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosW))) /

	(
	(((self cCoerce: next to:'float *') at: PrimVtxRasterPosW) -
		((self cCoerce: last to: 'float *') at: PrimVtxRasterPosW))
	+
	 (((self cCoerce: next to:'float *') at: PrimVtxRasterPosY) -
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosY))
	).! !

!B3DClipperPlugin methodsFor: 'clipping' stamp: 'ar 4/16/1999 06:03'!
clipPolygon: vtxArray count: vtxCount with: tempVtxArray mask: outMask
	| count |
	self var: #vtxArray declareC:'int *vtxArray'.
	self var: #tempVtxArray declareC:'int *tempVtxArray'.
	"Check if the polygon is outside one boundary only.
	If so, just do this single clipping operation avoiding multiple enumeration."
	outMask = OutLeftBit 
		ifTrue:[^self clipPolygonLeftFrom: tempVtxArray to: vtxArray count: vtxCount].
	outMask = OutRightBit 
		ifTrue:[^self clipPolygonRightFrom: tempVtxArray to: vtxArray count: vtxCount].
	outMask = OutTopBit 
		ifTrue:[^self clipPolygonTopFrom: tempVtxArray to: vtxArray count: vtxCount].
	outMask = OutBottomBit 
		ifTrue:[^self clipPolygonBottomFrom: tempVtxArray to: vtxArray count: vtxCount].
	outMask = OutFrontBit 
		ifTrue:[^self clipPolygonFrontFrom: tempVtxArray to: vtxArray count: vtxCount].
	outMask = OutBackBit 
		ifTrue:[^self clipPolygonBackFrom: tempVtxArray to: vtxArray count: vtxCount].
	"Just do each of the clipping operations"
	count := vtxCount.
	count := self clipPolygonLeftFrom: vtxArray to: tempVtxArray count: count.
	count = 0 ifTrue:[^0].
	count := self clipPolygonRightFrom: tempVtxArray to: vtxArray count: count.
	count = 0 ifTrue:[^0].
	count := self clipPolygonTopFrom: vtxArray to: tempVtxArray count: count.
	count = 0 ifTrue:[^0].
	count := self clipPolygonBottomFrom: tempVtxArray to: vtxArray count: count.
	count = 0 ifTrue:[^0].
	count := self clipPolygonFrontFrom: vtxArray to: tempVtxArray count: count.
	count = 0 ifTrue:[^0].
	count := self clipPolygonBackFrom: tempVtxArray to: vtxArray count: count.
	^count! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/17/1999 22:18'!
clipPolygonBackFrom: buf1 to: buf2 count: n
	| last next t outIndex inLast inNext |
	self var: #buf1 declareC:'int *buf1'.
	self var: #buf2 declareC:'int *buf2'.
	self var: #last declareC:'int *last'.
	self var: #next declareC:'int *next'.
	self var: #t declareC: 'double t'.
	outIndex := 0.
	last := buf1 + (n * PrimVertexSize).
	next := buf1 + PrimVertexSize.
	inLast := (last at: PrimVtxClipFlags) anyMask: InBackBit.
	1 to: n do:[:i|
		inNext := (next at: PrimVtxClipFlags) anyMask: InBackBit.
		inLast = inNext ifFalse:["Passes clip boundary"
			t := self backClipValueFrom: last to: next.
			outIndex := outIndex + 1.
			self interpolateFrom: (self cCoerce: last to:'float *')
				to: (self cCoerce: next to:'float *')
				at: t 
				into: (self cCoerce: (buf2 + (outIndex * PrimVertexSize)) to:'float*')].
		inNext ifTrue:[
			outIndex := outIndex+1.
			0 to: PrimVertexSize-1 do:[:j|
				buf2 at: (outIndex*PrimVertexSize + j) put: (next at: j)].
		].
		last := next.
		inLast := inNext.
		next := next + PrimVertexSize.
	].
	^outIndex! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/17/1999 22:18'!
clipPolygonBottomFrom: buf1 to: buf2 count: n
	| last next t outIndex inLast inNext |
	self var: #buf1 declareC:'int *buf1'.
	self var: #buf2 declareC:'int *buf2'.
	self var: #last declareC:'int *last'.
	self var: #next declareC:'int *next'.
	self var: #t declareC: 'double t'.
	outIndex := 0.
	last := buf1 + (n * PrimVertexSize).
	next := buf1 + PrimVertexSize.
	inLast := (last at: PrimVtxClipFlags) anyMask: InBottomBit.
	1 to: n do:[:i|
		inNext := (next at: PrimVtxClipFlags) anyMask: InBottomBit.
		inLast = inNext ifFalse:["Passes clip boundary"
			t := self bottomClipValueFrom: last to: next.
			outIndex := outIndex + 1.
			self interpolateFrom: (self cCoerce: last to:'float *')
				to: (self cCoerce: next to:'float *')
				at: t 
				into: (self cCoerce: (buf2 + (outIndex * PrimVertexSize)) to:'float*')].
		inNext ifTrue:[
			outIndex := outIndex+1.
			0 to: PrimVertexSize-1 do:[:j|
				buf2 at: (outIndex*PrimVertexSize + j) put: (next at: j)].
		].
		last := next.
		inLast := inNext.
		next := next + PrimVertexSize.
	].
	^outIndex! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/17/1999 22:18'!
clipPolygonFrontFrom: buf1 to: buf2 count: n
	| last next t outIndex inLast inNext |
	self var: #buf1 declareC:'int *buf1'.
	self var: #buf2 declareC:'int *buf2'.
	self var: #last declareC:'int *last'.
	self var: #next declareC:'int *next'.
	self var: #t declareC: 'double t'.
	outIndex := 0.
	last := buf1 + (n * PrimVertexSize).
	next := buf1 + PrimVertexSize.
	inLast := (last at: PrimVtxClipFlags) anyMask: InFrontBit.
	1 to: n do:[:i|
		inNext := (next at: PrimVtxClipFlags) anyMask: InFrontBit.
		inLast = inNext ifFalse:["Passes clip boundary"
			t := self frontClipValueFrom: last to: next.
			outIndex := outIndex + 1.
			self interpolateFrom: (self cCoerce: last to:'float *')
				to: (self cCoerce: next to:'float *')
				at: t 
				into: (self cCoerce: (buf2 + (outIndex * PrimVertexSize)) to:'float*')].
		inNext ifTrue:[
			outIndex := outIndex+1.
			0 to: PrimVertexSize-1 do:[:j|
				buf2 at: (outIndex*PrimVertexSize + j) put: (next at: j)].
		].
		last := next.
		inLast := inNext.
		next := next + PrimVertexSize.
	].
	^outIndex! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/17/1999 22:18'!
clipPolygonLeftFrom: buf1 to: buf2 count: n
	| last next t outIndex inLast inNext |
	self var: #buf1 declareC:'int *buf1'.
	self var: #buf2 declareC:'int *buf2'.
	self var: #last declareC:'int *last'.
	self var: #next declareC:'int *next'.
	self var: #t declareC: 'double t'.
	outIndex := 0.
	last := buf1 + (n * PrimVertexSize).
	next := buf1 + PrimVertexSize.
	inLast := (last at: PrimVtxClipFlags) anyMask: InLeftBit.
	1 to: n do:[:i|
		inNext := (next at: PrimVtxClipFlags) anyMask: InLeftBit.
		inLast = inNext ifFalse:["Passes clip boundary"
			t := self leftClipValueFrom: last to: next.
			outIndex := outIndex + 1.
			self interpolateFrom: (self cCoerce: last to:'float *')
				to: (self cCoerce: next to:'float *')
				at: t 
				into: (self cCoerce: (buf2 + (outIndex * PrimVertexSize)) to:'float*')].
		inNext ifTrue:[
			outIndex := outIndex+1.
			0 to: PrimVertexSize-1 do:[:j|
				buf2 at: (outIndex*PrimVertexSize + j) put: (next at: j)].
		].
		last := next.
		inLast := inNext.
		next := next + PrimVertexSize.
	].
	^outIndex! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/17/1999 22:18'!
clipPolygonRightFrom: buf1 to: buf2 count: n
	| last next t outIndex inLast inNext |
	self var: #buf1 declareC:'int *buf1'.
	self var: #buf2 declareC:'int *buf2'.
	self var: #last declareC:'int *last'.
	self var: #next declareC:'int *next'.
	self var: #t declareC: 'double t'.
	outIndex := 0.
	last := buf1 + (n * PrimVertexSize).
	next := buf1 + PrimVertexSize.
	inLast := (last at: PrimVtxClipFlags) anyMask: InRightBit.
	1 to: n do:[:i|
		inNext := (next at: PrimVtxClipFlags) anyMask: InRightBit.
		inLast = inNext ifFalse:["Passes clip boundary"
			t := self rightClipValueFrom: last to: next.
			outIndex := outIndex + 1.
			self interpolateFrom: (self cCoerce: last to:'float *')
				to: (self cCoerce: next to:'float *')
				at: t 
				into: (self cCoerce: (buf2 + (outIndex * PrimVertexSize)) to:'float*')].
		inNext ifTrue:[
			outIndex := outIndex+1.
			0 to: PrimVertexSize-1 do:[:j|
				buf2 at: (outIndex*PrimVertexSize + j) put: (next at: j)].
		].
		last := next.
		inLast := inNext.
		next := next + PrimVertexSize.
	].
	^outIndex! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/17/1999 22:19'!
clipPolygonTopFrom: buf1 to: buf2 count: n
	| last next t outIndex inLast inNext |
	self var: #buf1 declareC:'int *buf1'.
	self var: #buf2 declareC:'int *buf2'.
	self var: #last declareC:'int *last'.
	self var: #next declareC:'int *next'.
	self var: #t declareC: 'double t'.
	outIndex := 0.
	last := buf1 + (n * PrimVertexSize).
	next := buf1 + PrimVertexSize.
	inLast := (last at: PrimVtxClipFlags) anyMask: InTopBit.
	1 to: n do:[:i|
		inNext := (next at: PrimVtxClipFlags) anyMask: InTopBit.
		inLast = inNext ifFalse:["Passes clip boundary"
			t := self topClipValueFrom: last to: next.
			outIndex := outIndex + 1.
			self interpolateFrom: (self cCoerce: last to:'float *')
				to: (self cCoerce: next to:'float *')
				at: t 
				into: (self cCoerce: (buf2 + (outIndex * PrimVertexSize)) to:'float*')].
		inNext ifTrue:[
			outIndex := outIndex+1.
			0 to: PrimVertexSize-1 do:[:j|
				buf2 at: (outIndex*PrimVertexSize + j) put: (next at: j)].
		].
		last := next.
		inLast := inNext.
		next := next + PrimVertexSize.
	].
	^outIndex! !

!B3DClipperPlugin methodsFor: 'clipping' stamp: 'ar 4/16/1999 01:57'!
determineClipFlags: vtxArray count: count
	| vtxPtr fullMask w w2 flags x y z |
	self var: #vtxPtr declareC:'float *vtxPtr'.
	self var: #vtxArray declareC:'void *vtxArray'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #z declareC:'double z'.
	self var: #w declareC:'double w'.
	self var: #w2 declareC:'double w2'.
	vtxPtr := self cCoerce: vtxArray to: 'float *'.
	fullMask := InAllMask + OutAllMask.
	1 to: count do:[:i|
		w := vtxPtr at: PrimVtxRasterPosW.
		w2 := 0.0 - w.
		flags := 0.
		x := vtxPtr at: PrimVtxRasterPosX.
		x >= w2 ifTrue:[flags := flags bitOr: InLeftBit] ifFalse:[flags := flags bitOr: OutLeftBit].
		x <= w ifTrue:[flags := flags bitOr: InRightBit] ifFalse:[flags := flags bitOr: OutRightBit].
		y := vtxPtr at: PrimVtxRasterPosY.
		y >= w2 ifTrue:[flags := flags bitOr: InBottomBit] ifFalse:[flags := flags bitOr: OutBottomBit].
		y <= w ifTrue:[flags := flags bitOr: InTopBit] ifFalse:[flags := flags bitOr: OutTopBit].
		z := vtxPtr at: PrimVtxRasterPosZ.
		z >= w2 ifTrue:[flags := flags bitOr: InFrontBit] ifFalse:[flags := flags bitOr: OutFrontBit].
		z <= w ifTrue:[flags := flags bitOr: InBackBit] ifFalse:[flags := flags bitOr: OutBackBit].
		fullMask := fullMask bitAnd: flags.
		(self cCoerce: vtxPtr to:'int *') at: PrimVtxClipFlags put: flags.
		vtxPtr := vtxPtr + PrimVertexSize.
	].
	^fullMask! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/16/1999 06:43'!
frontClipValueFrom: last to: next
	self returnTypeC:'double'.
	^(0.0 - (((self cCoerce: last to: 'float *') at: PrimVtxRasterPosZ) + 
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosW))) /

	(
	(((self cCoerce: next to:'float *') at: PrimVtxRasterPosW) -
		((self cCoerce: last to: 'float *') at: PrimVtxRasterPosW))
	+
	 (((self cCoerce: next to:'float *') at: PrimVtxRasterPosZ) -
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosZ))
	).! !

!B3DClipperPlugin methodsFor: 'clipping' stamp: 'ar 4/21/1999 01:26'!
interpolateFrom: last to: next at: t into: out
	"Interpolate the primitive vertices last/next at the parameter t"
	| delta rgbaLast lastValue rgbaNext nextValue newValue x y z w w2 flags |
	self var: #last declareC:'float *last'.
	self var: #next declareC:'float *next'.
	self var: #out declareC:'float *out'.
	self var: #t declareC: 'double t'.
	self var: #delta declareC: 'double delta'.
	self var: #rgbaLast declareC:'unsigned int rgbaLast'.
	self var: #rgbaNext declareC:'unsigned int rgbaNext'.
	self var: #lastValue declareC:'unsigned int lastValue'.
	self var: #nextValue declareC:'unsigned int nextValue'.
	self var: #newValue declareC:'unsigned int newValue'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #z declareC:'double z'.
	self var: #w declareC:'double w'.
	self var: #w2 declareC:'double w2'.
	"Interpolate raster position"
	delta := (next at: PrimVtxRasterPosX) - (last at: PrimVtxRasterPosX).
	x := (last at: PrimVtxRasterPosX) + (delta * t).
	out at: PrimVtxRasterPosX put: (self cCoerce: x to: 'float').
	delta := (next at: PrimVtxRasterPosY) - (last at: PrimVtxRasterPosY).
	y := (last at: PrimVtxRasterPosY) + (delta * t).
	out at: PrimVtxRasterPosY put: (self cCoerce: y to: 'float').
	delta := (next at: PrimVtxRasterPosZ) - (last at: PrimVtxRasterPosZ).
	z := (last at: PrimVtxRasterPosZ) + (delta * t).
	out at: PrimVtxRasterPosZ put: (self cCoerce: z to: 'float').
	delta := (next at: PrimVtxRasterPosW) - (last at: PrimVtxRasterPosW).
	w := (last at: PrimVtxRasterPosW) + (delta * t).
	out at: PrimVtxRasterPosW put: (self cCoerce: w to: 'float').
	"Determine new clipFlags"
	w2 := 0.0 - w.
	flags := 0.
	x >= w2 ifTrue:[flags := flags bitOr: InLeftBit] ifFalse:[flags := flags bitOr: OutLeftBit].
	x <= w ifTrue:[flags := flags bitOr: InRightBit] ifFalse:[flags := flags bitOr: OutRightBit].
	y >= w2 ifTrue:[flags := flags bitOr: InBottomBit] ifFalse:[flags := flags bitOr: OutBottomBit].
	y <= w ifTrue:[flags := flags bitOr: InTopBit] ifFalse:[flags := flags bitOr: OutTopBit].
	z >= w2 ifTrue:[flags := flags bitOr: InFrontBit] ifFalse:[flags := flags bitOr: OutFrontBit].
	z <= w ifTrue:[flags := flags bitOr: InBackBit] ifFalse:[flags := flags bitOr: OutBackBit].
	(self cCoerce: out to: 'int *') at: PrimVtxClipFlags put: flags.

	"Interpolate color"
	rgbaLast := (self cCoerce: last to:'unsigned int *') at: PrimVtxColor32.
	lastValue := rgbaLast bitAnd: 255. rgbaLast := rgbaLast >> 8.
	rgbaNext := (self cCoerce: next to: 'unsigned int *') at: PrimVtxColor32.
	nextValue := rgbaNext bitAnd: 255. rgbaNext := rgbaNext >> 8.
	delta := (self cCoerce: (nextValue - lastValue) to:'int') * t.
	newValue := (lastValue + delta) asInteger.

	lastValue := rgbaLast bitAnd: 255. rgbaLast := rgbaLast >> 8.
	nextValue := rgbaNext bitAnd: 255. rgbaNext := rgbaNext >> 8.
	delta := (self cCoerce: (nextValue - lastValue) to:'int') * t.
	newValue := newValue + ((lastValue + delta) asInteger << 8).

	lastValue := rgbaLast bitAnd: 255. rgbaLast := rgbaLast >> 8.
	nextValue := rgbaNext bitAnd: 255. rgbaNext := rgbaNext >> 8.
	delta := (self cCoerce: (nextValue - lastValue) to:'int') * t.
	newValue := newValue + ((lastValue + delta) asInteger << 16).

	lastValue := rgbaLast bitAnd: 255.
	nextValue := rgbaNext bitAnd: 255.
	delta := (self cCoerce: (nextValue - lastValue) to:'int') * t.
	newValue := newValue + ((lastValue + delta) asInteger << 24).

	(self cCoerce: out to:'unsigned int*') at: PrimVtxColor32 put: newValue.

	"Interpolate texture coordinates"
	delta := (next at: PrimVtxTexCoordU) - (last at: PrimVtxTexCoordU).
	out at: PrimVtxTexCoordU put: (self cCoerce: (last at: PrimVtxTexCoordU) + (delta * t) to:'float').
	delta := (next at: PrimVtxTexCoordV) - (last at: PrimVtxTexCoordV).
	out at: PrimVtxTexCoordV put: (self cCoerce: (last at: PrimVtxTexCoordV) + (delta * t) to:'float').
! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/16/1999 06:43'!
leftClipValueFrom: last to: next
	self returnTypeC:'double'.
	^(0.0 - (((self cCoerce: last to: 'float *') at: PrimVtxRasterPosX) + 
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosW))) /

	(
	(((self cCoerce: next to:'float *') at: PrimVtxRasterPosW) -
		((self cCoerce: last to: 'float *') at: PrimVtxRasterPosW))
	+
	 (((self cCoerce: next to:'float *') at: PrimVtxRasterPosX) -
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosX))
	).! !

!B3DClipperPlugin methodsFor: 'clipping' stamp: 'ar 5/16/2001 18:00'!
mapVB: vtxArray ofSize: vtxCount into: boxArray
	| left right top bottom vtxPtr flags w x y oop floatOop |
	self var: #vtxPtr declareC:'float *vtxPtr'.
	self var: #vtxArray declareC:'void *vtxArray'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #w declareC:'double w'.
	self var: #left declareC:'double left'.
	self var: #right declareC:'double right'.
	self var: #top declareC:'double top'.
	self var: #bottom declareC:'double bottom'.

	vtxPtr := self cCoerce: vtxArray to: 'float *'.

	1 to: vtxCount do:[:i|
		flags := (self cCoerce: vtxPtr to:'int *') at: PrimVtxClipFlags.
		w := vtxPtr at: PrimVtxRasterPosW.
		w = 0.0 ifFalse:[w := 1.0 / w].
		(flags bitAnd: OutLeftBit) ~= 0
			ifTrue:[x := -1.0]
			ifFalse:[(flags bitAnd: OutRightBit) ~= 0
				ifTrue:[x := 1.0]
				ifFalse:[x := (vtxPtr at: PrimVtxRasterPosX) * w]].
		(flags bitAnd: OutTopBit) ~= 0
			ifTrue:[y := -1.0]
			ifFalse:[(flags bitAnd: OutBottomBit) ~= 0
				ifTrue:[y := 1.0]
				ifFalse:[y := (vtxPtr at: PrimVtxRasterPosY) * w]].
		i = 1 ifTrue:[
			left := right := x.
			top := bottom := y.
		].
		x < left ifTrue:[left := x].
		x > right ifTrue:[right := x].
		y < top ifTrue:[top := y].
		y > bottom ifTrue:[bottom := y].
		vtxPtr := vtxPtr + PrimVertexSize.
	].
	oop := boxArray.

	interpreterProxy pushRemappableOop: oop.
	floatOop := interpreterProxy floatObjectOf: left.
	oop := interpreterProxy popRemappableOop.
	interpreterProxy storePointer: 0 ofObject: oop withValue: floatOop.

	interpreterProxy pushRemappableOop: oop.
	floatOop := interpreterProxy floatObjectOf: top.
	oop := interpreterProxy popRemappableOop.
	interpreterProxy storePointer: 1 ofObject: oop withValue: floatOop.

	interpreterProxy pushRemappableOop: oop.
	floatOop := interpreterProxy floatObjectOf: right.
	oop := interpreterProxy popRemappableOop.
	interpreterProxy storePointer: 2 ofObject: oop withValue: floatOop.

	interpreterProxy pushRemappableOop: oop.
	floatOop := interpreterProxy floatObjectOf: bottom.
	oop := interpreterProxy popRemappableOop.
	interpreterProxy storePointer: 3 ofObject: oop withValue: floatOop.
! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/16/1999 01:56'!
rightClipValueFrom: last to: next
	self returnTypeC:'double'.
	^(((self cCoerce: last to: 'float *') at: PrimVtxRasterPosX) - 
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosW)) /

	(
	(((self cCoerce: next to:'float *') at: PrimVtxRasterPosW) -
		((self cCoerce: last to: 'float *') at: PrimVtxRasterPosW))
	-
	 (((self cCoerce: next to:'float *') at: PrimVtxRasterPosX) -
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosX))
	).! !

!B3DClipperPlugin methodsFor: 'clipping utilities' stamp: 'ar 4/16/1999 01:56'!
topClipValueFrom: last to: next
	self returnTypeC:'double'.
	^(((self cCoerce: last to: 'float *') at: PrimVtxRasterPosY) - 
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosW)) /

	(
	(((self cCoerce: next to:'float *') at: PrimVtxRasterPosW) -
		((self cCoerce: last to: 'float *') at: PrimVtxRasterPosW))
	-
	 (((self cCoerce: next to:'float *') at: PrimVtxRasterPosY) -
		((self cCoerce: last to:'float *') at: PrimVtxRasterPosY))
	).! !

!B3DEnginePlugin class methodsFor: 'translation' stamp: 'ar 5/16/2000 20:05'!
declareCVarsIn: cg
	cg var: 'bbPluginName' declareC:'char bbPluginName[256] = "BitBltPlugin"'.! !

!B3DEnginePlugin class methodsFor: 'translation' stamp: 'ar 2/8/1999 20:48'!
moduleName
	^'Squeak3D'! !

!B3DEnginePlugin class methodsFor: 'translation' stamp: 'tpr 7/4/2001 15:10'!
requiresCrossPlatformFiles
	"If there cross platform files to be associated with the plugin, here is where you want to flag"
	^true! !

!B3DEnginePlugin class methodsFor: 'translation' stamp: 'tpr 5/14/2001 12:08'!
shouldBeTranslated
"B3DEnginePlugin should be translated but its subclasses should not since they are incorporated within this class's translation process"
	^self == B3DEnginePlugin! !

!B3DEnginePlugin class methodsFor: 'translation' stamp: 'dtl 8/11/2016 10:54'!
translateInDirectory: directory doInlining: inlineFlag
"Special case for the 3D code. Check all the classes' timestamps, not just one"
	| cg fname fstat tStamp|
	 fname := self moduleName, '.c'.
	tStamp := 0.

	tStamp := { B3DEnginePlugin. B3DTransformerPlugin. B3DVertexBufferPlugin. B3DShaderPlugin. B3DClipperPlugin. B3DPickerPlugin. B3DRasterizerPlugin}
					inject: 0 into: [:tS :cl| tS max: cl timeStamp].

	"don't translate if the file is newer than my timeStamp"
	fstat := directory entryAt: fname ifAbsent:[nil].
	fstat ifNotNil:[tStamp < fstat modificationTime ifTrue:[^nil]].

	self initialize.

	cg := self buildCodeGenerator.

	{  B3DTransformerPlugin. B3DVertexBufferPlugin. B3DShaderPlugin. B3DClipperPlugin. B3DPickerPlugin. B3DRasterizerPlugin} do: 
		[:theClass | 
		theClass initialize.
		cg addClass: theClass.
		theClass declareCVarsIn: cg].
	cg inferTypesForImplicitlyTypedVariablesAndMethods.
	self pruneUnusedInterpreterPluginMethodsIn: cg.
	cg storeCodeOnFile: (directory fullNameFor: fname)  doInlining: inlineFlag.
	^cg exportedPrimitiveNames asArray! !

!B3DEnginePlugin methodsFor: 'initialize-release' stamp: 'ar 5/16/2000 20:05'!
initialiseModule
	self export: true.
	loadBBFn := interpreterProxy ioLoadFunction: 'loadBitBltFrom' From: bbPluginName.
	copyBitsFn := interpreterProxy ioLoadFunction: 'copyBitsFromtoat' From: bbPluginName.
	^(loadBBFn ~= 0 and:[copyBitsFn ~= 0])! !

!B3DEnginePlugin methodsFor: 'initialize-release' stamp: 'ar 5/16/2000 20:05'!
moduleUnloaded: aModuleName
	"The module with the given name was just unloaded.
	Make sure we have no dangling references."
	self export: true.
	self var: #aModuleName type: 'char *'.
	(aModuleName strcmp: bbPluginName) = 0 ifTrue:[
		"BitBlt just shut down. How nasty."
		loadBBFn := 0.
		copyBitsFn := 0.
	].! !

!B3DEnginePlugin methodsFor: 'primitive support' stamp: 'ar 2/14/1999 00:01'!
stackMatrix: index
	"Load a 4x4 transformation matrix from the interpreter stack.
	Return a pointer to the matrix data if successful, nil otherwise."
	| oop |
	self inline: false.
	self returnTypeC:'void*'.
	oop := interpreterProxy stackObjectValue: index.
	oop = nil ifTrue:[^nil].
	((interpreterProxy isWords: oop) and:[(interpreterProxy slotSizeOf: oop) = 16])
		ifTrue:[^interpreterProxy firstIndexableField: oop].
	^nil! !

!B3DEnginePlugin methodsFor: 'primitive support' stamp: 'ar 4/12/1999 02:15'!
stackPrimitiveIndexArray: stackIndex ofSize: nItems validate: aBool forVertexSize: maxIndex
	"Load a primitive index array from the interpreter stack.
	If aBool is true then check that all the indexes are in the range (1,maxIndex).
	Return a pointer to the index data if successful, nil otherwise."
	| oop oopSize idxPtr index |
	self inline: false.
	self returnTypeC:'void*'.
	self var: #idxPtr declareC:'int *idxPtr'.

	oop := interpreterProxy stackObjectValue: stackIndex.
	oop = nil ifTrue:[^nil].
	(interpreterProxy isWords: oop) ifFalse:[^nil].
 	oopSize := interpreterProxy slotSizeOf: oop.
	oopSize < nItems ifTrue:[^nil].
	idxPtr := self cCoerce: (interpreterProxy firstIndexableField: oop) to:'int *'.
	aBool ifTrue:[
		0 to: nItems-1 do:[:i|
			index := idxPtr at: i.
			(index < 0 or:[index > maxIndex]) ifTrue:[^nil]]].
	^idxPtr! !

!B3DEnginePlugin methodsFor: 'primitive support' stamp: 'ar 2/14/1999 00:00'!
stackPrimitiveVertex: index
	"Load a primitive vertex from the interpreter stack.
	Return a pointer to the vertex data if successful, nil otherwise."
	| oop |
	self inline: false.
	self returnTypeC:'void*'.
	oop := interpreterProxy stackObjectValue: index.
	oop = nil ifTrue:[^nil].
	((interpreterProxy isWords: oop) and:[(interpreterProxy slotSizeOf: oop) = PrimVertexSize])
		ifTrue:[^interpreterProxy firstIndexableField: oop].
	^nil! !

!B3DEnginePlugin methodsFor: 'primitive support' stamp: 'ar 2/14/1999 00:00'!
stackPrimitiveVertexArray: index ofSize: nItems
	"Load a primitive vertex array from the interpreter stack.
	Return a pointer to the vertex data if successful, nil otherwise."
	| oop oopSize |
	self inline: false.
	self returnTypeC:'void*'.
	oop := interpreterProxy stackObjectValue: index.
	oop = nil ifTrue:[^nil].
	(interpreterProxy isWords: oop) ifTrue:[
 		oopSize := interpreterProxy slotSizeOf: oop.
		(oopSize >= nItems * PrimVertexSize and:[oopSize \\ PrimVertexSize = 0])
			ifTrue:[^interpreterProxy firstIndexableField: oop]].
	^nil! !

B3DEnginePlugin subclass: #B3DPickerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins'!

!B3DPickerPlugin methodsFor: 'primitives' stamp: 'ar 6/2/1999 11:59'!
b3dComputeMinIndexZ
	"Primitive. Compute and return the index for the minimal z value of all objects in the vertex buffer."
	| idxSize vtxSize primType vtxArray idxArray minIndex |
	self export: true.
	self inline: false.
	self var: #vtxArray declareC:'float *vtxArray'.
	self var: #idxArray declareC:'int *idxArray'.
	interpreterProxy methodArgumentCount = 5
		ifFalse:[^interpreterProxy primitiveFail].
	idxSize := interpreterProxy stackIntegerValue: 0.
	vtxSize := interpreterProxy stackIntegerValue: 2.
	primType := interpreterProxy stackIntegerValue: 4.
	interpreterProxy failed ifTrue:[^nil].
	vtxArray := self stackPrimitiveVertexArray: 3 ofSize: vtxSize.
	idxArray := self stackPrimitiveIndexArray: 1 ofSize: idxSize validate: true forVertexSize: vtxSize.
	(vtxArray == nil or:[idxArray == nil or:[interpreterProxy failed]])
		ifTrue:[^interpreterProxy primitiveFail].
	(primType < 1 or:[primType > 6])
		ifTrue:[^interpreterProxy primitiveFail].
	primType <= 3 ifTrue:[
		minIndex := self processNonIndexedIDX: vtxArray ofSize: vtxSize.
	] ifFalse:[
		minIndex := self processIndexedIDX: vtxArray ofSize: vtxSize idxArray: idxArray idxSize: idxSize.
	].
	interpreterProxy failed ifFalse:[
		interpreterProxy pop: 6. "nArgs+rcvr"
		interpreterProxy pushInteger: minIndex.
	].! !

!B3DPickerPlugin methodsFor: 'primitives' stamp: 'ar 4/18/1999 02:59'!
b3dComputeMinZ
	"Primitive. Compute and return the minimal z value of all objects in the vertex buffer."
	| idxSize vtxSize primType vtxArray idxArray minZ |
	self export: true.
	self inline: false.
	self var: #vtxArray declareC:'float *vtxArray'.
	self var: #idxArray declareC:'int *idxArray'.
	self var: #minZ declareC:'double minZ'.
	interpreterProxy methodArgumentCount = 5
		ifFalse:[^interpreterProxy primitiveFail].
	idxSize := interpreterProxy stackIntegerValue: 0.
	vtxSize := interpreterProxy stackIntegerValue: 2.
	primType := interpreterProxy stackIntegerValue: 4.
	interpreterProxy failed ifTrue:[^nil].
	vtxArray := self stackPrimitiveVertexArray: 3 ofSize: vtxSize.
	idxArray := self stackPrimitiveIndexArray: 1 ofSize: idxSize validate: true forVertexSize: vtxSize.
	(vtxArray == nil or:[idxArray == nil or:[interpreterProxy failed]])
		ifTrue:[^interpreterProxy primitiveFail].
	(primType < 1 or:[primType > 6])
		ifTrue:[^interpreterProxy primitiveFail].
	primType <= 3 ifTrue:[
		minZ := self processNonIndexed: vtxArray ofSize: vtxSize.
	] ifFalse:[
		minZ := self processIndexed: vtxArray ofSize: vtxSize idxArray: idxArray idxSize: idxSize.
	].
	interpreterProxy failed ifFalse:[
		interpreterProxy pop: 6. "nArgs+rcvr"
		interpreterProxy pushFloat: minZ.
	].! !

!B3DPickerPlugin methodsFor: 'processing' stamp: 'ar 4/18/1999 03:05'!
processIndexed: vtxArray ofSize: vtxSize idxArray: idxArray idxSize: idxSize
	| vtxPtr zValue wValue minZ index |
	self returnTypeC:'double'.
	self var: #vtxArray declareC:'float *vtxArray'.
	self var: #vtxPtr declareC:'float *vtxPtr'.
	self var: #idxArray declareC:'int *idxArray'.
	self var: #wValue declareC:'double wValue'.
	self var: #zValue declareC:'double zValue'.
	self var: #minZ declareC:'double minZ'.
	minZ := 10.0.
	1 to: idxSize do:[:i|
		index := idxArray at: i.
		index > 0 ifTrue:[
			vtxPtr := vtxArray + (index-1 * PrimVertexSize).
			zValue := vtxPtr at: PrimVtxRasterPosZ.
			wValue := vtxPtr at: PrimVtxRasterPosW.
			wValue = 0.0 ifFalse:[zValue := zValue / wValue].
			zValue < minZ ifTrue:[minZ := zValue].
		].
	].
	^minZ! !

!B3DPickerPlugin methodsFor: 'processing' stamp: 'ar 6/2/1999 12:00'!
processIndexedIDX: vtxArray ofSize: vtxSize idxArray: idxArray idxSize: idxSize
	| vtxPtr zValue wValue minZ minIndex index |
	self var: #vtxArray declareC:'float *vtxArray'.
	self var: #vtxPtr declareC:'float *vtxPtr'.
	self var: #idxArray declareC:'int *idxArray'.
	self var: #wValue declareC:'double wValue'.
	self var: #zValue declareC:'double zValue'.
	self var: #minZ declareC:'double minZ'.
	minZ := 10.0.
	minIndex := 0.
	1 to: idxSize do:[:i|
		index := idxArray at: i.
		index > 0 ifTrue:[
			vtxPtr := vtxArray + (index-1 * PrimVertexSize).
			zValue := vtxPtr at: PrimVtxRasterPosZ.
			wValue := vtxPtr at: PrimVtxRasterPosW.
			wValue = 0.0 ifFalse:[zValue := zValue / wValue].
			(minIndex = 0 or:[zValue < minZ]) ifTrue:[
				minIndex := i.
				minZ := zValue].
		].
	].
	^minIndex! !

!B3DPickerPlugin methodsFor: 'processing' stamp: 'ar 4/18/1999 02:49'!
processNonIndexed: vtxArray ofSize: vtxSize
	| vtxPtr zValue wValue minZ |
	self returnTypeC:'double'.
	self var: #vtxArray declareC:'float *vtxArray'.
	self var: #vtxPtr declareC:'float *vtxPtr'.
	self var: #wValue declareC:'double wValue'.
	self var: #zValue declareC:'double zValue'.
	self var: #minZ declareC:'double minZ'.
	minZ := 10.0.
	vtxPtr := vtxArray.
	1 to: vtxSize do:[:i|
		zValue := vtxPtr at: PrimVtxRasterPosZ.
		wValue := vtxPtr at: PrimVtxRasterPosW.
		wValue = 0.0 ifFalse:[zValue := zValue / wValue].
		zValue < minZ ifTrue:[minZ := zValue].
	].
	^minZ! !

!B3DPickerPlugin methodsFor: 'processing' stamp: 'ar 6/2/1999 12:00'!
processNonIndexedIDX: vtxArray ofSize: vtxSize
	| vtxPtr zValue wValue minZ minIndex |
	self var: #vtxArray declareC:'float *vtxArray'.
	self var: #vtxPtr declareC:'float *vtxPtr'.
	self var: #wValue declareC:'double wValue'.
	self var: #zValue declareC:'double zValue'.
	self var: #minZ declareC:'double minZ'.
	minZ := 10.0.
	minIndex := 0.
	vtxPtr := vtxArray.
	1 to: vtxSize do:[:i|
		zValue := vtxPtr at: PrimVtxRasterPosZ.
		wValue := vtxPtr at: PrimVtxRasterPosW.
		wValue = 0.0 ifFalse:[zValue := zValue / wValue].
		(minIndex = 0 or:[zValue < minZ]) ifTrue:[
			minIndex := i.
			minZ := zValue].
	].
	^minIndex! !

B3DEnginePlugin subclass: #B3DRasterizerPlugin
	instanceVariableNames: 'state viewport'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins'!

!B3DRasterizerPlugin class methodsFor: 'translation' stamp: 'ar 5/15/2000 23:12'!
declareCVarsIn: cg
	cg addHeaderFile:'"b3d.h"'.
	cg var: #viewport type: #'B3DPrimitiveViewport'.
	cg var: #state type: #'B3DRasterizerState'! !

!B3DRasterizerPlugin methodsFor: 'primitives' stamp: 'bf 3/20/2012 14:00'!
b3dInitPrimitiveObject
	| vtxSize vtxArray idxSize idxArray primitive primOop primObj primSize textureIndex |
	self export: true.
	self inline: false.
	self var: #vtxArray declareC:'int *vtxArray'.
	self var: #idxArray declareC:'int *idxArray'.
	self var: #primObj declareC:'void *primObj'.
	"Check argument count"
	interpreterProxy methodArgumentCount = 8
		ifFalse:[^interpreterProxy primitiveFail].

	"Fetch the texture index"
	textureIndex := interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue:[^nil].

	"Load the viewport"
	self loadViewportFrom: 1.
	interpreterProxy failed ifTrue:[^nil].

	"Fetch and validate the primitive vertex array"
	vtxSize := interpreterProxy stackIntegerValue: 4.
	vtxArray := self stackPrimitiveVertexArray: 5 ofSize: vtxSize.
	vtxArray = nil
		ifTrue:[^interpreterProxy primitiveFail].
	"Fetch and validate the primitive index array"
	idxSize := interpreterProxy stackIntegerValue: 2.
	idxArray := self stackPrimitiveIndexArray: 3 ofSize: idxSize validate: true forVertexSize: vtxSize.
	idxArray = nil
		ifTrue:[^interpreterProxy primitiveFail].

	"Fetch and validate the primitive type"
	primitive := interpreterProxy stackIntegerValue: 6.
	(primitive < 1 or:[primitive > PrimTypeMax]) 
		ifTrue:[^interpreterProxy primitiveFail].

	"For now we only support indexed triangles, quads and polys"
	(primitive = 3 or:[primitive = 5 or:[primitive = 6]]) ifFalse:[^interpreterProxy primitiveFail].

	"Load the primitive object"
	primOop := interpreterProxy stackObjectValue: 7.
	interpreterProxy failed ifTrue:[^nil].
	(interpreterProxy isWords: primOop)
		ifFalse:[^interpreterProxy primitiveFail].
	primObj := interpreterProxy firstIndexableField: primOop.
	primSize := interpreterProxy byteSizeOf: primOop.

	"Do the work"
	primitive = 3 ifTrue:[
		(self cCode: 'b3dAddPolygonObject((void*) primObj, primSize, B3D_FACE_RGB, textureIndex, (B3DPrimitiveVertex*) vtxArray, vtxSize, &viewport) !!= B3D_NO_ERROR')
			ifTrue:[^interpreterProxy primitiveFail].
	].
	primitive = 5 ifTrue:[
		(self cCode:'b3dAddIndexedTriangleObject((void*) primObj, primSize, B3D_FACE_RGB, textureIndex, (B3DPrimitiveVertex*) vtxArray, vtxSize, (B3DInputFace*) idxArray, idxSize / 3, &viewport) !!= B3D_NO_ERROR') 
			ifTrue:[^interpreterProxy primitiveFail].
	].
	primitive = 6 ifTrue:[
		(self cCode:'b3dAddIndexedQuadObject((void*) primObj, primSize, B3D_FACE_RGB, textureIndex, (B3DPrimitiveVertex*) vtxArray, vtxSize, (B3DInputQuad*) idxArray, idxSize / 4, &viewport) !!= B3D_NO_ERROR')
			ifTrue:[^interpreterProxy primitiveFail].
	].
	"Pop args+rcvr; return primitive object"
	interpreterProxy pop: 9.
	interpreterProxy push: primOop.! !

!B3DRasterizerPlugin methodsFor: 'primitives' stamp: 'bf 3/20/2012 14:02'!
b3dInitializeRasterizerState
	"Primitive. Initialize the primitive level objects of the given rasterizer."
	| stateOop objOop objLen obj |
	self export: true.
	self inline: false.
	self var: #obj declareC:'void *obj'.

	"Check argument count"
	interpreterProxy methodArgumentCount = 0
		ifFalse:[^interpreterProxy primitiveFail].

	stateOop := interpreterProxy stackObjectValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	((interpreterProxy isPointers: stateOop) and:[(interpreterProxy slotSizeOf: stateOop) >= 7])
		ifFalse:[^interpreterProxy primitiveFail].

	objOop := interpreterProxy fetchPointer: 0 ofObject: stateOop.
	((interpreterProxy isIntegerObject: objOop) or:[(interpreterProxy isWords: objOop)  not])
		ifTrue:[^interpreterProxy primitiveFail].
	objLen := interpreterProxy byteSizeOf: objOop.
	obj := interpreterProxy firstIndexableField: objOop.
	(self cCode: 'b3dInitializeFaceAllocator(obj, objLen) !!= B3D_NO_ERROR') 
		ifTrue:[^interpreterProxy primitiveFail].

	objOop := interpreterProxy fetchPointer: 1 ofObject: stateOop.
	((interpreterProxy isIntegerObject: objOop) or:[(interpreterProxy isWords: objOop)  not])
		ifTrue:[^interpreterProxy primitiveFail].
	objLen := interpreterProxy byteSizeOf: objOop.
	obj := interpreterProxy firstIndexableField: objOop.
	(self cCode: 'b3dInitializeEdgeAllocator(obj, objLen) !!= B3D_NO_ERROR') 
		ifTrue:[^interpreterProxy primitiveFail].

	objOop := interpreterProxy fetchPointer: 2 ofObject: stateOop.
	((interpreterProxy isIntegerObject: objOop) or:[(interpreterProxy isWords: objOop)  not])
		ifTrue:[^interpreterProxy primitiveFail].
	objLen := interpreterProxy byteSizeOf: objOop.
	obj := interpreterProxy firstIndexableField: objOop.
	(self cCode: 'b3dInitializeAttrAllocator(obj, objLen) !!= B3D_NO_ERROR') 
		ifTrue:[^interpreterProxy primitiveFail].

	objOop := interpreterProxy fetchPointer: 3 ofObject: stateOop.
	((interpreterProxy isIntegerObject: objOop) or:[(interpreterProxy isWords: objOop)  not])
		ifTrue:[^interpreterProxy primitiveFail].
	objLen := interpreterProxy byteSizeOf: objOop.
	obj := interpreterProxy firstIndexableField: objOop.
	(self cCode: 'b3dInitializeAET(obj, objLen) !!= B3D_NO_ERROR') 
		ifTrue:[^interpreterProxy primitiveFail].

	objOop := interpreterProxy fetchPointer: 4 ofObject: stateOop.
	((interpreterProxy isIntegerObject: objOop) or:[(interpreterProxy isWords: objOop)  not])
		ifTrue:[^interpreterProxy primitiveFail].
	objLen := interpreterProxy byteSizeOf: objOop.
	obj := interpreterProxy firstIndexableField: objOop.
	(self cCode: 'b3dInitializeEdgeList(obj, objLen) !!= B3D_NO_ERROR') 
		ifTrue:[^interpreterProxy primitiveFail].

	objOop := interpreterProxy fetchPointer: 5 ofObject: stateOop.
	((interpreterProxy isIntegerObject: objOop) or:[(interpreterProxy isWords: objOop)  not])
		ifTrue:[^interpreterProxy primitiveFail].
	objLen := interpreterProxy byteSizeOf: objOop.
	obj := interpreterProxy firstIndexableField: objOop.
	(self cCode: 'b3dInitializeFillList(obj, objLen) !!= B3D_NO_ERROR') 
		ifTrue:[^interpreterProxy primitiveFail].

	"Don't pop anything - return the receiver"! !

!B3DRasterizerPlugin methodsFor: 'primitives' stamp: 'ar 4/14/1999 02:06'!
b3dPrimitiveObjectSize
	"Primitive. Return the minimal number of words needed for a primitive object."
	| objSize |
	self export: true.
	self inline: false.
	objSize := (self cCode:'sizeof(B3DPrimitiveObject) + sizeof(B3DPrimitiveVertex)') // 4 + 1.
	interpreterProxy pop: 1.
	interpreterProxy pushInteger: objSize.! !

!B3DRasterizerPlugin methodsFor: 'primitives' stamp: 'ar 4/14/1999 05:22'!
b3dPrimitiveTextureSize
	"Primitive. Return the minimal number of words needed for a primitive object."
	| objSize |
	self export: true.
	self inline: false.
	objSize := (self cCode:'sizeof(B3DTexture)') // 4 + 1.
	interpreterProxy pop: 1.
	interpreterProxy pushInteger: objSize.! !

!B3DRasterizerPlugin methodsFor: 'primitives' stamp: 'ar 4/12/1999 02:19'!
b3dRasterizerVersion
	"Primitive. Return the version of the rasterizer."
	self export: true.
	self inline: false.
	interpreterProxy pop: 1.
	interpreterProxy pushInteger: 1. "Version 1"! !

!B3DRasterizerPlugin methodsFor: 'primitives' stamp: 'bf 3/20/2012 13:58'!
b3dStartRasterizer
	"Primitive. Start the rasterizer."
	| errCode |
	self export: true.
	self inline: false.
	"Check argument count"
	interpreterProxy methodArgumentCount = 3
		ifFalse:[^interpreterProxy primitiveFail].

	"Load the base rasterizer state"
	(self loadRasterizerState: 2)
		ifFalse:[^interpreterProxy primitiveFail].
	"Load the textures"
	self loadTexturesFrom: 0.
	interpreterProxy failed ifTrue:[^nil].
	"And the objects"
	self loadObjectsFrom: 1.
	interpreterProxy failed ifTrue:[^nil].
	"And go ..."
	errCode := self cCode:'b3dMainLoop(&state, B3D_NO_ERROR)'.
	self storeObjectsInto: 1.
	interpreterProxy pop: 4.
	interpreterProxy pushInteger: errCode.! !

!B3DRasterizerPlugin methodsFor: 'primitive support' stamp: 'eem 6/28/2016 12:22'!
loadObjectsFrom: stackIndex
	| arrayOop arraySize objArray objOop objPtr |
	<var:#objArray type: #'B3DPrimitiveObject **'>
	<var:#objPtr type: #'B3DPrimitiveObject *'>
	arrayOop := interpreterProxy stackValue: stackIndex.
	(interpreterProxy fetchClassOf: arrayOop) == interpreterProxy classArray ifFalse:
		[^interpreterProxy primitiveFail].
	arraySize := interpreterProxy slotSizeOf: arrayOop.
	arraySize > (self cCode:'state.nObjects') ifTrue:
		[^interpreterProxy primitiveFail].
	objArray := self cCode:'state.objects'.
	0 to: arraySize-1 do:[:i|
		objOop := interpreterProxy fetchPointer: i ofObject: arrayOop.
		(interpreterProxy isWords: objOop) ifFalse:
			[^interpreterProxy primitiveFail].
		objPtr := self cCoerce: (interpreterProxy firstIndexableField: objOop) to:#'B3DPrimitiveObject *'.
		(self cCode:'objPtr->magic !!= B3D_PRIMITIVE_OBJECT_MAGIC') ifTrue:
			[^interpreterProxy primitiveFail].
		self cCode:'objPtr->__oop__ = objOop'.
		objArray at: i put: objPtr.
	]! !

!B3DRasterizerPlugin methodsFor: 'primitive support' stamp: 'eem 6/28/2016 12:30'!
loadRasterizerState: stackIndex
	"Load the rasterizer state from the given stack index."
	| stateOop obj objPtr objLen |
	self var: #objPtr type: #'void *'.
	(copyBitsFn = 0 or:[loadBBFn = 0]) ifTrue:[
		"We need loadBitBltFrom/copyBits here so try to load it implicitly"
		self initialiseModule ifFalse:[^false].
	].
	stateOop := interpreterProxy stackValue: stackIndex.
	((interpreterProxy isPointers: stateOop)
	 and:[(interpreterProxy slotSizeOf: stateOop) >= 10]) ifFalse:[^false].

	obj := interpreterProxy fetchPointer: 0 ofObject: stateOop.
	(interpreterProxy isWords: obj) ifFalse: [^false].
	objPtr := interpreterProxy firstIndexableField: obj.
	self cCode:'state.faceAlloc = objPtr'.

	obj := interpreterProxy fetchPointer: 1 ofObject: stateOop.
	(interpreterProxy isWords: obj) ifFalse: [^false].
	objPtr := interpreterProxy firstIndexableField: obj.
	self cCode:'state.edgeAlloc = objPtr'.

	obj := interpreterProxy fetchPointer: 2 ofObject: stateOop.
	(interpreterProxy isWords: obj) ifFalse: [^false].
	objPtr := interpreterProxy firstIndexableField: obj.
	self cCode:'state.attrAlloc = objPtr'.

	obj := interpreterProxy fetchPointer: 3 ofObject: stateOop.
	(interpreterProxy isWords: obj) ifFalse: [^false].
	objPtr := interpreterProxy firstIndexableField: obj.
	self cCode:'state.aet = objPtr'.

	obj := interpreterProxy fetchPointer: 4 ofObject: stateOop.
	(interpreterProxy isWords: obj) ifFalse: [^false].
	objPtr := interpreterProxy firstIndexableField: obj.
	self cCode:'state.addedEdges = objPtr'.

	obj := interpreterProxy fetchPointer: 5 ofObject: stateOop.
	(interpreterProxy isWords: obj) ifFalse: [^false].
	objPtr := interpreterProxy firstIndexableField: obj.
	self cCode:'state.fillList = objPtr'.

	obj := interpreterProxy fetchPointer: 6 ofObject: stateOop.
	obj = interpreterProxy nilObject ifTrue:[
		self cCode:'state.nObjects = 0'.
		self cCode:'state.objects = NULL'.
	] ifFalse:[
		(interpreterProxy isWords: obj) ifFalse: [^false].
		objLen := interpreterProxy slotSizeOf: obj.
		objPtr := interpreterProxy firstIndexableField: obj.
		self cCode:'state.objects = (B3DPrimitiveObject **)objPtr'.
		self cCode:'state.nObjects = objLen'.
	].

	obj := interpreterProxy fetchPointer: 7 ofObject: stateOop.
	obj = interpreterProxy nilObject ifTrue:[
		self cCode:'state.nTextures = 0'.
		self cCode:'state.textures = NULL'.
	] ifFalse:[
		(interpreterProxy isWords: obj) ifFalse: [^false].
		objLen := interpreterProxy byteSizeOf: obj.
		objPtr := interpreterProxy firstIndexableField: obj.
		self cCode:'state.textures = (B3DTexture *)objPtr'.
		self cCode:'state.nTextures = objLen / sizeof(B3DTexture)'.
	].

	obj := interpreterProxy fetchPointer: 8 ofObject: stateOop.
	obj = interpreterProxy nilObject ifTrue:[
		self cCode:'state.spanSize = 0'.
		self cCode:'state.spanBuffer = NULL'.
	] ifFalse:[
		(interpreterProxy fetchClassOf: obj) = interpreterProxy classBitmap
			ifFalse:[^false].
		objLen := interpreterProxy slotSizeOf: obj.
		objPtr := interpreterProxy firstIndexableField: obj.
		self cCode:'state.spanBuffer = (unsigned int *)objPtr'.
		self cCode:'state.spanSize = objLen'.
	].

	obj := interpreterProxy fetchPointer: 9 ofObject: stateOop.
	obj = interpreterProxy nilObject ifTrue:[
		self cCode:'state.spanDrawer = NULL'.
	] ifFalse:[
		(self cCode: '((sqInt (*) (sqInt))loadBBFn)(obj)') ifFalse:[^false].
		self cCode:'state.spanDrawer = (b3dDrawBufferFunction) copyBitsFn'.
	].

	^interpreterProxy failed not
! !

!B3DRasterizerPlugin methodsFor: 'primitive support' stamp: 'bf 3/20/2012 13:58'!
loadTexture: textureOop into: destPtr
	"Note: This still uses the old-style textures"
	| form formBits formWidth formHeight formDepth texWrap texInterpolate texEnvMode bitsPtr |
	self var: #bitsPtr declareC:'void *bitsPtr'.
	self var: #destPtr declareC:'B3DTexture *destPtr'.
	"Fetch and validate the form"
	form := textureOop.
	(interpreterProxy isPointers: form) ifFalse:[^false].
	(interpreterProxy slotSizeOf: form) < 8 ifTrue:[^false].
	formBits := interpreterProxy fetchPointer: 0 ofObject: form.
	formWidth := interpreterProxy fetchInteger: 1 ofObject: form.
	formHeight := interpreterProxy fetchInteger: 2 ofObject: form.
	formDepth := interpreterProxy fetchInteger: 3 ofObject: form.
	texWrap := interpreterProxy booleanValueOf: 
		(interpreterProxy fetchPointer: 5 ofObject: form).
	texInterpolate := interpreterProxy booleanValueOf: 
		(interpreterProxy fetchPointer: 6 ofObject: form).
	texEnvMode := interpreterProxy fetchInteger: 7 ofObject: form.
	interpreterProxy failed ifTrue:[^false].
	(formWidth < 1 or:[formHeight < 1 or:[formDepth ~= 32]]) ifTrue:[^false].
	(interpreterProxy fetchClassOf: formBits) = interpreterProxy classBitmap ifFalse:[^false].
	(interpreterProxy byteSizeOf: formBits) = (formWidth * formHeight * 4) ifFalse:[^false].
	(texEnvMode < 0 or:[texEnvMode > 1]) ifTrue:[^false].

	"Now fetch the bits"
	bitsPtr := interpreterProxy firstIndexableField: formBits.
	"Set the texture parameters"
	^self cCode:'b3dLoadTexture(destPtr, formWidth, formHeight, formDepth, (unsigned int*) bitsPtr, 0, NULL) == B3D_NO_ERROR'.! !

!B3DRasterizerPlugin methodsFor: 'primitive support' stamp: 'ar 4/14/1999 05:52'!
loadTexturesFrom: stackIndex
	| arrayOop destPtr n textureOop |
	self var: #destPtr declareC:'B3DTexture *destPtr'.
	arrayOop := interpreterProxy stackObjectValue: stackIndex.
	(interpreterProxy fetchClassOf: arrayOop) == interpreterProxy classArray
		ifFalse:[^interpreterProxy primitiveFail].
	n := interpreterProxy slotSizeOf: arrayOop.
	n := n min: (self cCode: 'state.nTextures').
	0 to: n-1 do:[:i|
		destPtr := self cCode:'state.textures + i'.
		textureOop := interpreterProxy fetchPointer: i ofObject: arrayOop.
		(self loadTexture: textureOop into: destPtr) 
			ifFalse:[^interpreterProxy primitiveFail].
	].
	^0! !

!B3DRasterizerPlugin methodsFor: 'primitive support' stamp: 'ar 4/10/1999 23:24'!
loadViewportFrom: stackIndex
	"Load the viewport from the given stack index"
	| oop p1 p2 x0 y0 x1 y1 |
	oop := interpreterProxy stackObjectValue: stackIndex.
	interpreterProxy failed ifTrue:[^nil].
	(interpreterProxy isPointers: oop)
		ifFalse:[^interpreterProxy primitiveFail].
	(interpreterProxy slotSizeOf: oop) < 2
		ifTrue:[^interpreterProxy primitiveFail].
	p1 := interpreterProxy fetchPointer: 0 ofObject: oop.
	p2 := interpreterProxy fetchPointer: 1 ofObject: oop.
	(interpreterProxy fetchClassOf: p1) = interpreterProxy classPoint
		ifFalse:[^interpreterProxy primitiveFail].
	(interpreterProxy fetchClassOf: p2) = interpreterProxy classPoint
		ifFalse:[^interpreterProxy primitiveFail].
	x0 := interpreterProxy fetchInteger: 0 ofObject: p1.
	y0 := interpreterProxy fetchInteger: 1 ofObject: p1.
	x1 := (interpreterProxy fetchInteger: 0 ofObject: p2).
	y1 := (interpreterProxy fetchInteger: 1 ofObject: p2).
	interpreterProxy failed ifTrue:[^nil].
	self cCode:'viewport.x0 = x0'.
	self cCode:'viewport.y0 = y0'.
	self cCode:'viewport.x1 = x1'.
	self cCode:'viewport.y1 = y1'.
	^0! !

!B3DRasterizerPlugin methodsFor: 'primitives' stamp: 'ar 5/16/2000 20:06'!
primitiveSetBitBltPlugin
	"Primitive. Set the BitBlt plugin to use."
	| pluginName length ptr needReload |
	self export: true.
	self var: #ptr declareC:'char *ptr'.
	pluginName := interpreterProxy stackValue: 0.
	"Must be string to work"
	(interpreterProxy isBytes: pluginName) 
		ifFalse:[^interpreterProxy primitiveFail].
	length := interpreterProxy byteSizeOf: pluginName.
	length >= 256 
		ifTrue:[^interpreterProxy primitiveFail].
	ptr := interpreterProxy firstIndexableField: pluginName.
	needReload := false.
	0 to: length-1 do:[:i|
		"Compare and store the plugin to be used"
		(bbPluginName at: i) = (ptr at: i) ifFalse:[
			bbPluginName at: i put: (ptr at: i).
			needReload := true]].
	(bbPluginName at: length) = 0 ifFalse:[
		bbPluginName at: length put: 0.
		needReload := true].
	needReload ifTrue:[
		self initialiseModule 
			ifFalse:[^interpreterProxy primitiveFail]].
	interpreterProxy pop: 1. "Return receiver"! !

!B3DRasterizerPlugin methodsFor: 'primitive support' stamp: 'bf 3/20/2012 13:59'!
storeObjectsInto: stackIndex
	| arrayOop arraySize objOop |
	arrayOop := interpreterProxy stackObjectValue: stackIndex.
	arraySize := self cCode: 'state.nObjects'.
	0 to: arraySize-1 do:[:i|
		objOop := self cCode:'state.objects[i]->__oop__'.
		interpreterProxy storePointer: i ofObject: arrayOop withValue: objOop.
	].! !

B3DEnginePlugin subclass: #B3DShaderPlugin
	instanceVariableNames: 'litVertex primLight primMaterial l2vDirection l2vDistance l2vSpecDir lightFlags vbFlags lightScale vtxInColor vtxOutColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins'!

!B3DShaderPlugin class methodsFor: 'translation' stamp: 'ar 5/15/2000 23:13'!
declareCVarsIn: cg
	cg var: #litVertex type: #'float*'.
	cg var: #primLight type: #'float*'.
	cg var: #primMaterial type: #'float*'.
	cg var: #l2vDirection declareC: 'double l2vDirection[3]'.
	cg var: #l2vSpecDir declareC: 'double l2vSpecDir[3]'.
	cg var: #vtxInColor declareC: 'double vtxInColor[4]'.
	cg var: #vtxOutColor declareC: 'double vtxOutColor[4]'.
	cg var: #l2vDistance type: #'double'.
	cg var: #lightScale type: #'double'! !

!B3DShaderPlugin methodsFor: 'shading' stamp: 'ar 2/17/1999 19:40'!
addPart: lightPart from: materialPart trackFlag: vbTrackFlag scale: scale
	"Add the given light part to the output color, scaled by the given scale factor.
	If the given flag is set in vbFlags then load the part from the primitive vertex"
	| rPart gPart bPart aPart |
	self var: #lightPart declareC:'float *lightPart'.
	self var: #materialPart declareC:'float *materialPart'.
	self var: #scale declareC:'double scale'.
	self var: #rPart declareC:'double rPart'.
	self var: #gPart declareC:'double gPart'.
	self var: #bPart declareC:'double bPart'.
	self var: #aPart declareC:'double aPart'.
	self inline: true.
	(vbFlags anyMask: vbTrackFlag) ifTrue:[
		rPart := (vtxInColor at: 0) * (lightPart at: 0) * scale.
		gPart := (vtxInColor at: 1) * (lightPart at: 1) * scale.
		bPart := (vtxInColor at: 2) * (lightPart at: 2) * scale.
		aPart := (vtxInColor at: 3) * (lightPart at: 3) * scale.
	] ifFalse:[
		"Note: This should be pre-computed."
		rPart := (materialPart at: 0) * (lightPart at: 0) * scale.
		gPart := (materialPart at: 1) * (lightPart at: 1) * scale.
		bPart := (materialPart at: 2) * (lightPart at: 2) * scale.
		aPart := (materialPart at: 3) * (lightPart at: 3) * scale.
	].
	vtxOutColor at: 0 put: (vtxOutColor at: 0) + rPart.
	vtxOutColor at: 1 put: (vtxOutColor at: 1) + gPart.
	vtxOutColor at: 2 put: (vtxOutColor at: 2) + bPart.
	vtxOutColor at: 3 put: (vtxOutColor at: 3) + aPart.! !

!B3DShaderPlugin methodsFor: 'primitives' stamp: 'ar 2/17/1999 19:40'!
b3dShadeVertexBuffer
	"Primitive. Shade all the vertices in the vertex buffer using the given array of primitive light sources. Return true on success."
	| lightArray vtxCount vtxArray lightCount |
	self export: true.
	self inline: false.
	self var: #vtxArray declareC:'float *vtxArray'.
	vbFlags := interpreterProxy stackIntegerValue: 0.
	primMaterial := self stackMaterialValue: 1.
	lightArray := self stackLightArrayValue: 2.
	vtxCount := interpreterProxy stackIntegerValue: 3.
	vtxArray := self stackPrimitiveVertexArray: 4 ofSize: vtxCount.
	(vtxArray = nil or:[primMaterial = nil or:[interpreterProxy failed]])
		ifTrue:[^interpreterProxy primitiveFail].
	"Setup"
	litVertex := vtxArray.
	lightCount := interpreterProxy slotSizeOf: lightArray.
	"Go over all vertices"
	1 to: vtxCount do:[:i|
		"Load the primitive vertex"
		self loadPrimitiveVertex.
		"Load initial color (e.g., emissive part of vertex and/or material)"
		(vbFlags anyMask: VBTrackEmission) ifTrue:[
			"Load color from vertex"
			vtxOutColor at: 0 put: (vtxInColor at: 0) + (primMaterial at: EmissionRed).
			vtxOutColor at: 1 put: (vtxInColor at: 1) + (primMaterial at: EmissionGreen).
			vtxOutColor at: 2 put: (vtxInColor at: 2) + (primMaterial at: EmissionBlue).
			vtxOutColor at: 3 put: (vtxInColor at: 3) + (primMaterial at: EmissionAlpha).
		] ifFalse:[
			vtxOutColor at: 0 put: (primMaterial at: EmissionRed).
			vtxOutColor at: 1 put: (primMaterial at: EmissionGreen).
			vtxOutColor at: 2 put: (primMaterial at: EmissionBlue).
			vtxOutColor at: 3 put: (primMaterial at: EmissionAlpha).
		].
		"For each enabled light source"
		0 to: lightCount-1 do:[:j|
			"Fetch the light source"
			primLight := self fetchLightSource: j ofObject: lightArray.
			"Setup values"
			self loadPrimitiveLightSource.
			"Compute the color from the light source"
			self shadeVertex.
		].
		"Store the computed color back"
		self storePrimitiveVertex.
		"And step on to the next vertex"
		litVertex := litVertex + PrimVertexSize.
	].
	"Clean up stack"
	interpreterProxy pop: 6. "Pop args+rcvr"
	interpreterProxy pushBool: true.! !

!B3DShaderPlugin methodsFor: 'primitives' stamp: 'ar 2/17/1999 04:32'!
b3dShaderVersion
	"Return the current shader version."
	self export: true.
	self inline: false.
	interpreterProxy pop: 1.
	interpreterProxy pushInteger: 1.	"Version 1"! !

!B3DShaderPlugin methodsFor: 'shading' stamp: 'ar 2/17/1999 19:39'!
computeAttenuation
	"Compute the attenuation for the current light and vertex"
	lightScale := 1.0.
	(lightFlags anyMask: FlagAttenuated) ifTrue:[
		lightScale := 1.0 / ((primLight at: PrimLightAttenuationConstant) + 
			(l2vDistance * ((primLight at: PrimLightAttenuationLinear) + 
				(l2vDistance * (primLight at: PrimLightAttenuationSquared)))))].
! !

!B3DShaderPlugin methodsFor: 'shading' stamp: 'ar 4/17/1999 22:31'!
computeDirection
	"Compute the direction for the current light and vertex"
	| scale |
	self inline: true.
	self var: #scale declareC:'double scale'.
	(lightFlags anyMask: FlagPositional) ifTrue:[
		"Must compute the direction for this vertex"
		l2vDirection at: 0 put: (litVertex at: PrimVtxPositionX) - (primLight at: PrimLightPositionX).
		l2vDirection at: 1 put: (litVertex at: PrimVtxPositionY) - (primLight at: PrimLightPositionY).
		l2vDirection at: 2 put: (litVertex at: PrimVtxPositionZ) - (primLight at: PrimLightPositionZ).
		"l2vDistance := self dotProductOf: l2vDirection with: l2vDirection."
		l2vDistance := ((l2vDirection at: 0) * (l2vDirection at: 0)) +
						((l2vDirection at: 1) * (l2vDirection at: 1)) +
							((l2vDirection at: 2) * (l2vDirection at: 2)).
		(l2vDistance = 0.0 or:[l2vDistance = 1.0]) 
			ifFalse:[	l2vDistance := l2vDistance sqrt.
					scale := -1.0/l2vDistance].
		l2vDirection at: 0 put: (l2vDirection at: 0) * scale.
		l2vDirection at: 1 put: (l2vDirection at: 1) * scale.
		l2vDirection at: 2 put: (l2vDirection at: 2) * scale.
	] ifFalse:[
		(lightFlags anyMask: FlagDirectional) ifTrue:[
			l2vDirection at: 0 put: (primLight at: PrimLightDirectionX).
			l2vDirection at: 1 put: (primLight at: PrimLightDirectionY).
			l2vDirection at: 2 put: (primLight at: PrimLightDirectionZ).
		].
	].
! !

!B3DShaderPlugin methodsFor: 'shading' stamp: 'ar 4/17/1999 22:39'!
computeSpecularDirection
	"Computes
		l2vSpecDir := l2vSpecDir - vtx position safelyNormalized.
	"
	| scale |
	self var: #scale declareC:'double scale'.
	scale := self inverseLengthOfFloat: litVertex + PrimVtxPosition.
	l2vSpecDir at: 0 put: (l2vSpecDir at: 0) - ((litVertex at: PrimVtxPositionX) * scale).
	l2vSpecDir at: 1 put: (l2vSpecDir at: 1) - ((litVertex at: PrimVtxPositionY) * scale).
	l2vSpecDir at: 2 put: (l2vSpecDir at: 2) - ((litVertex at: PrimVtxPositionZ) * scale).
! !

!B3DShaderPlugin methodsFor: 'shading' stamp: 'ar 4/17/1999 22:39'!
computeSpotFactor
	"Compute the spot factor for a spot light"
	| cosAngle minCos deltaCos |
	self returnTypeC:'double'.
	self var: #cosAngle declareC:'double cosAngle'.
	self var: #minCos declareC:'double minCos'.
	self var: #deltaCos declareC:'double deltaCos'.
	"Compute cos angle between direction of the spot light and direction to vertex"
	cosAngle := self dotProductOfFloat: primLight + PrimLightDirection withDouble: l2vDirection.
	cosAngle := 0.0 - cosAngle.
	minCos := primLight at: SpotLightMinCos.
	cosAngle < minCos ifTrue:[^0.0].
	deltaCos := primLight at: SpotLightDeltaCos.
	deltaCos <= 0.00001 ifTrue:[
		"No delta -- a sharp boundary between on and off.
		Since off has already been determined above, we are on"
		^1.0].
	"Scale the angle to 0/1 range"
	cosAngle := (cosAngle - minCos) / deltaCos.
	^cosAngle raisedTo: (primLight at: SpotLightExponent)
! !

!B3DShaderPlugin methodsFor: 'shading' stamp: 'ar 4/17/1999 22:39'!
dotProductOfFloat: v1 withDouble: v2
	self var: #v1 declareC:'float * v1'.
	self var: #v2 declareC:'double *v2'.
	self returnTypeC:'double'.
	^((v1 at: 0) * (v2 at: 0)) +
		((v1 at: 1) * (v2 at: 1)) +
			((v1 at: 2) * (v2 at: 2)).
! !

!B3DShaderPlugin methodsFor: 'primitive support' stamp: 'ar 2/15/1999 22:33'!
fetchLightSource: index ofObject: anArray
	"Fetch the primitive light source from the given array.
	Note: No checks are done within here - that happened in stackLightArrayValue:"
	| lightOop |
	self inline: true.
	self returnTypeC:'void*'.
	lightOop := interpreterProxy fetchPointer: index ofObject: anArray.
	^interpreterProxy firstIndexableField: lightOop! !

!B3DShaderPlugin methodsFor: 'shading' stamp: 'ar 4/17/1999 22:38'!
inverseLengthOfDouble: aVector
	| scale |
	self returnTypeC:'double'.
	self var: #aVector declareC:'double * aVector'.
	self var: #scale declareC:'double scale'.
	"scale := self dotProductOf: aVector with: aVector."
	scale := ((aVector at: 0) * (aVector at: 0)) +
				((aVector at: 1) * (aVector at: 1)) +
					((aVector at: 2) * (aVector at: 2)).
	(scale = 0.0 or:[scale = 1.0]) ifTrue:[^scale].
	^1.0 / scale sqrt! !

!B3DShaderPlugin methodsFor: 'shading' stamp: 'ar 4/17/1999 22:38'!
inverseLengthOfFloat: aVector
	| scale |
	self returnTypeC:'double'.
	self var: #aVector declareC:'float * aVector'.
	self var: #scale declareC:'double scale'.
	"scale := self dotProductOf: aVector with: aVector."
	scale := ((aVector at: 0) * (aVector at: 0)) +
				((aVector at: 1) * (aVector at: 1)) +
					((aVector at: 2) * (aVector at: 2)).
	(scale = 0.0 or:[scale = 1.0]) ifTrue:[^scale].
	^1.0 / scale sqrt! !

!B3DShaderPlugin methodsFor: 'other' stamp: 'ar 2/17/1999 19:35'!
loadPrimitiveLightSource
	self inline: true.
	lightFlags := (self cCoerce: primLight to: 'int*') at: PrimLightFlags.! !

!B3DShaderPlugin methodsFor: 'other' stamp: 'ar 2/17/1999 19:40'!
loadPrimitiveVertex
	"Load the necessary values from the current primitive vertex"
	| rgba |
	self inline: true.
	rgba := (self cCoerce: litVertex to:'int*') at: PrimVtxColor32.
	vtxInColor at: 2 put: (rgba bitAnd: 255) * (1.0 / 255.0).
	rgba := rgba >> 8.
	vtxInColor at: 1 put: (rgba bitAnd: 255) * (1.0 / 255.0).
	rgba := rgba >> 8.
	vtxInColor at: 0 put: (rgba bitAnd: 255) * (1.0 / 255.0).
	rgba := rgba >> 8.
	vtxInColor at: 3 put: (rgba bitAnd: 255) * (1.0 / 255.0).
! !

!B3DShaderPlugin methodsFor: 'shading' stamp: 'ar 4/17/1999 22:40'!
shadeVertex
	| cosAngle specularFactor |
	self var: #cosAngle declareC:'double cosAngle'.
	self var: #specularFactor declareC:'double specularFactor'.
	self computeDirection.
	self computeAttenuation.

	(lightFlags anyMask: FlagHasSpot) ifTrue:[
		lightScale := lightScale * self computeSpotFactor.
	].

	"Compute ambient and diffuse part only if lightScale is non-zero."
	(lightScale > 0.001) ifTrue:[
		"Compute the ambient part"
		(lightFlags anyMask: FlagAmbientPart) ifTrue:[
			self addPart: (primLight + AmbientPart) 
				from: primMaterial + AmbientPart 
				trackFlag: VBTrackAmbient 
				scale: lightScale.
		].

		"Compute the diffuse part"
		(lightFlags anyMask: FlagDiffusePart) ifTrue:[
			"Compute angle from light->vertex to vertex normal"
			cosAngle := self dotProductOfFloat: (litVertex + PrimVtxNormal) withDouble: l2vDirection.
			"For one-sided lighting negate cosAngle if necessary"
			((vbFlags bitAnd: VBTwoSidedLighting) = 0 and:[cosAngle < 0.0])
				ifTrue:[cosAngle := 0.0 - cosAngle].
			"For two-sided lighting check if cosAngle > 0.0 meaning that it is a front face"
			cosAngle > 0.0 ifTrue:[
				self addPart: primLight + DiffusePart 
					from: primMaterial + DiffusePart 
					trackFlag: VBTrackDiffuse 
					scale: lightScale * cosAngle.
			].
		].
	]. "lightScale > 0.001"

	"Compute the specular part"
	((lightFlags anyMask: FlagSpecularPart) and:[
		(primMaterial at: MaterialShininess) > 0.0]) ifTrue:[
		"Compute specular part"
		l2vSpecDir at: 0 put: (l2vDirection at: 0).
		l2vSpecDir at: 1 put: (l2vDirection at: 1).
		l2vSpecDir at: 2 put: (l2vDirection at: 2).
		(vbFlags anyMask: VBUseLocalViewer) 
			ifTrue:[self computeSpecularDirection]
			ifFalse:[l2vSpecDir at: 2 put: (l2vSpecDir at: 2) - 1.0].
		cosAngle := self dotProductOfFloat: (litVertex + PrimVtxNormal) withDouble: l2vSpecDir.
		cosAngle > 0.0 ifTrue:[
			"Normalize the angle"
			cosAngle := cosAngle * (self inverseLengthOfDouble: l2vSpecDir).
			"cosAngle should be somewhere between 0 and 1.
			If not, then the vertex normal was not normalized"
			cosAngle > 1.0 ifTrue:[
				specularFactor := cosAngle raisedTo: (primMaterial at: MaterialShininess).
			] ifFalse:[
				cosAngle = 0.0 
					ifTrue:[specularFactor := 1.0]
					ifFalse:[specularFactor := cosAngle raisedTo: (primMaterial at: MaterialShininess)].
			].
			self addPart: primLight + SpecularPart 
				from: primMaterial + SpecularPart 
				trackFlag: VBTrackSpecular 
				scale: specularFactor.
		].
	].! !

!B3DShaderPlugin methodsFor: 'primitive support' stamp: 'ar 2/15/1999 22:29'!
stackLightArrayValue: stackIndex
	"Load an Array of B3DPrimitiveLights from the given stack index"
	| oop array arraySize |
	self inline: false.
	array := interpreterProxy stackObjectValue: stackIndex.
	interpreterProxy failed ifTrue:[^nil].
	(interpreterProxy fetchClassOf: array) = interpreterProxy classArray
		ifFalse:[^interpreterProxy primitiveFail].
	arraySize := interpreterProxy slotSizeOf: array.
	0 to: arraySize-1 do:[:i|
		oop := interpreterProxy fetchPointer: i ofObject: array.
		(interpreterProxy isIntegerObject: oop)
			ifTrue:[^interpreterProxy primitiveFail].
		((interpreterProxy isWords: oop) and:[(interpreterProxy slotSizeOf: oop) = PrimLightSize])
			ifFalse:[^interpreterProxy primitiveFail].
	].
	^array! !

!B3DShaderPlugin methodsFor: 'primitive support' stamp: 'ar 2/15/1999 19:22'!
stackMaterialValue: stackIndex
	"Load a B3DMaterial from the given stack index"
	| oop |
	self inline: false.
	self returnTypeC:'void *'.
	oop := interpreterProxy stackObjectValue: stackIndex.
	interpreterProxy failed ifTrue:[^nil].
	((interpreterProxy isWords: oop) and:[(interpreterProxy slotSizeOf: oop) = MaterialSize])
		ifTrue:[^interpreterProxy firstIndexableField: oop].
	^nil! !

!B3DShaderPlugin methodsFor: 'other' stamp: 'ar 2/17/1999 19:41'!
storePrimitiveVertex
	"Store the computed output color back into the current primitive vertex.
	Clamp the r,g,b,a part to be in the range 0-255."
	| r g b a |
	self inline: true.
	r := ((vtxOutColor at: 0) * 255) asInteger.
	r := (r min: 255) max: 0.
	g := ((vtxOutColor at: 1) * 255) asInteger.
	g := (g min: 255) max: 0.
	b := ((vtxOutColor at: 2) * 255) asInteger.
	b := (b min: 255) max: 0.
	a := ((vtxOutColor at: 3) * 255) asInteger.
	a := (a min: 255) max: 0.
	"The following is equal to b + (g << 8) + (r << 16) + (a << 24)"
	(self cCoerce: litVertex to:'int*') 
		at: PrimVtxColor32 put: b + (g + (r + (a << 8) << 8) << 8). 
! !

B3DEnginePlugin subclass: #B3DTransformerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins'!

!B3DTransformerPlugin methodsFor: 'transforming' stamp: 'ar 2/13/1999 23:45'!
analyzeMatrix3x3Length: m
	"Check if the matrix scales normals to non-unit length."
	| det |
	self var: #m declareC:'float *m'.
	self var: #det declareC:'double det'.
	det := 	((m at: 0) * (m at: 5) * (m at: 10)) -
			((m at: 2) * (m at: 5) * (m at: 8)) + 
			((m at: 4) * (m at: 9) * (m at: 2)) - 
			((m at: 6) * (m at: 9) * (m at: 0)) +
			((m at: 8) * (m at: 1) * (m at: 6)) -
			((m at: 10) * (m at: 1) * (m at: 4)).
	^det < 0.99 or:[det > 1.01]! !

!B3DTransformerPlugin methodsFor: 'transforming' stamp: 'ar 2/13/1999 23:45'!
analyzeMatrix: m
	"Analyze the matrix and return the appropriate flags"
	| flags |
	self var: #m declareC:'float *m'.
	"Check the perspective"
	flags := 0.
	((m at: 12) = 0.0 and:[(m at: 13) = 0.0 and:[(m at: 14) = 0.0 and:[(m at: 15) = 1.0]]]) ifTrue:[
		flags := flags bitOr: FlagM44NoPerspective.
		"Check translation"
		((m at: 3) = 0.0 and:[(m at: 7) = 0.0 and:[(m at: 11) = 0.0]]) ifTrue:[
			flags := flags bitOr: FlagM44NoTranslation.
			"Check for identity"
			((m at: 0) = 1.0 and:[(m at: 5) = 1.0 and:[(m at: 10) = 1.0 and:[
				(m at: 1) = 0.0 and:[(m at: 2) = 0.0 and:[
				(m at: 4) = 0.0 and:[(m at: 6) = 0.0 and:[
				(m at: 8) = 0.0 and:[(m at: 9) = 0.0]]]]]]]]) ifTrue:[
					flags := flags bitOr: FlagM44Identity.
			].
		].
	].
	^flags! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 5/22/2000 17:12'!
b3dInplaceHouseHolderInvert
	"Primitive. Perform an inplace house holder matrix inversion"
	| rcvr d x sigma beta sum s m |
	self export: true.
	self var: #rcvr declareC:'float *rcvr'.
	self var: #m declareC:'double m[4][4]'.
	self var: #x declareC:'double x[4][4] = { {1, 0, 0, 0}, {0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 1} }'.
	self var: #d declareC:'double d[4][4]'.
	self var: #sigma declareC:'double sigma'.
	self var: #beta declareC:'double beta'.
	self var: #sum declareC:'double sum'.
	self var: #s declareC:'double s'.

	self cCode:'' inSmalltalk:[
		m := CArrayAccessor on: 
				((1 to: 4) collect:[:i| CArrayAccessor on: (Array new: 4)]).
		x := CArrayAccessor on: (Array
				with: (CArrayAccessor on: #(1.0 0.0 0.0 0.0) copy)
				with: (CArrayAccessor on: #(0.0 1.0 0.0 0.0) copy)
				with: (CArrayAccessor on: #(0.0 0.0 1.0 0.0) copy)
				with: (CArrayAccessor on: #(0.0 0.0 0.0 1.0) copy)).
		d := CArrayAccessor on: 
				((1 to: 4) collect:[:i| CArrayAccessor on: (Array new: 4)]).
	].
	rcvr := self stackMatrix: 0.
	0 to: 3 do:[:i| 0 to: 3 do:[:j|
		(m at: i) at: j put: (rcvr at: i*4+j)]].
	0 to: 3 do:[:j|
		sigma := 0.0.
		j to: 3 do:[:i| sigma := sigma + (((m at: i) at: j)  * ((m at: i) at: j))].
		sigma < 1.0e-10 ifTrue:[^interpreterProxy primitiveFail]. "matrix is singular"
		(((m at: j) at: j) < 0.0) 
			ifTrue:[ s:= sigma sqrt]
			ifFalse:[ s:= 0.0 - sigma sqrt].
		0 to: 3 do:[:r| (d at: j) at: r put: s].
		beta := 1.0 / ( s * ((m at: j) at: j) - sigma).
		(m at: j) at: j put: (((m at: j) at: j) - s).
		"update remaining columns"
		j+1 to: 3 do:[:k|
			sum := 0.0.
			j to: 3 do:[:i| sum := sum + (((m at: i) at: j) * ((m at: i) at: k))].
			sum := sum * beta.
			j to: 3 do:[:i| 
				(m at: i) at: k put: (((m at: i) at: k) + (((m at: i) at: j) * sum))]].
		"update vector"
		0 to: 3 do:[:r|
			sum := 0.0.
			j to: 3 do:[:i| 
				sum := sum + (((x at: i) at: r) * ((m at: i) at: j))].
			sum := sum * beta.
			j to: 3 do:[:i| 
				(x at: i) at: r put:(((x at: i) at: r) + (sum * ((m at: i) at: j)))].
		].
	].
	"Now calculate result"
	0 to: 3 do:[:r|
		3 to: 0 by: -1 do:[:i|
			i+1 to: 3 do:[:j|
				(x at: i) at: r put: (((x at: i) at: r) - (((x at: j) at: r) * ((m at: i) at: j))) ].
			(x at: i) at: r put: (((x at: i) at: r) / ((d at: i) at: r))].
	].
	0 to: 3 do:[:i| 0 to: 3 do:[:j|
		rcvr at: i*4+j put: (self cCoerce: ((x at: i) at: j) to:'float')]].
	"Return receiver"! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 9/18/2002 17:33'!
b3dOrthoNormInverseMatrix
	| srcOop dstOop src dst x y z rx ry rz |
	self export: true.
	self var: #src declareC:'float *src'.
	self var: #dst declareC:'float *dst'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #z declareC:'double z'.
	self var: #rx declareC:'double rx'.
	self var: #ry declareC:'double ry'.
	self var: #rz declareC:'double rz'.

	interpreterProxy methodArgumentCount = 0
		ifFalse:[^interpreterProxy primitiveFail].
	srcOop := interpreterProxy stackObjectValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	((interpreterProxy isWords: srcOop) and:[(interpreterProxy slotSizeOf: srcOop) = 16])
		ifFalse:[^interpreterProxy primitiveFail].
	dstOop := interpreterProxy clone: srcOop.
	"reload srcOop in case of GC"
	srcOop := interpreterProxy stackObjectValue: 0.
	src := interpreterProxy firstIndexableField: srcOop.
	dst := interpreterProxy firstIndexableField: dstOop.

	"Transpose upper 3x3 matrix"
	"dst at: 0 put: (src at: 0)."	dst at: 1 put: (src at: 4). 	dst at: 2 put: (src at: 8). 
	dst at: 4 put: (src at: 1). 	"dst at: 5 put: (src at: 5)."	dst at: 6 put: (src at: 9). 
	dst at: 8 put: (src at: 2). 	dst at: 9 put: (src at: 6). 	"dst at: 10 put: (src at: 10)."

	"Compute inverse translation vector"
	x := src at: 3..
	y := src at: 7.
	z := src at: 11.
	rx := (x * (dst at: 0)) + (y * (dst at: 1)) + (z * (dst at: 2)).
	ry := (x * (dst at: 4)) + (y * (dst at: 5)) + (z * (dst at: 6)).
	rz := (x * (dst at: 8)) + (y * (dst at: 9)) + (z * (dst at: 10)).

	dst at: 3 put: (self cCoerce: 0.0-rx to: 'float').
	dst at: 7 put: (self cCoerce: 0.0-ry to: 'float').
	dst at: 11 put: (self cCoerce: 0.0-rz to: 'float').

	interpreterProxy pop: 1.
	interpreterProxy push: dstOop.
! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 9/25/2002 11:37'!
b3dTransformDirection
	| x y z rx ry rz matrix vertex v3Oop |
	self export: true.

	self var: #vertex declareC:'float *vertex'.
	self var: #matrix declareC:'float *matrix'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #z declareC:'double z'.
	self var: #rx declareC:'double rx'.
	self var: #ry declareC:'double ry'.
	self var: #rz declareC:'double rz'.

	interpreterProxy methodArgumentCount = 1
		ifFalse:[^interpreterProxy primitiveFail].
	v3Oop := interpreterProxy stackObjectValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	((interpreterProxy isWords: v3Oop) and:[(interpreterProxy slotSizeOf: v3Oop) = 3])
		ifFalse:[^interpreterProxy primitiveFail].
	vertex := interpreterProxy firstIndexableField: v3Oop.
	matrix := self stackMatrix: 1.
	(matrix == nil) ifTrue:[^interpreterProxy primitiveFail].

	x := vertex at: 0.
	y := vertex at: 1.
	z := vertex at: 2.

	rx := (x * (matrix at: 0)) + (y * (matrix at: 1)) + (z * (matrix at: 2)).
	ry := (x * (matrix at: 4)) + (y * (matrix at: 5)) + (z * (matrix at: 6)).
	rz := (x * (matrix at: 8)) + (y * (matrix at: 9)) + (z * (matrix at: 10)).

	v3Oop := interpreterProxy clone: v3Oop.
	vertex := interpreterProxy firstIndexableField: v3Oop.

	vertex at: 0 put: (self cCoerce: rx to: 'float').
	vertex at: 1 put: (self cCoerce: ry to:'float').
	vertex at: 2 put: (self cCoerce: rz to: 'float').

	interpreterProxy pop: 2.
	interpreterProxy push: v3Oop.
! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 2/14/1999 00:02'!
b3dTransformMatrixWithInto
	"Transform two matrices into the third"
	| m1 m2 m3 |
	self export: true.
	self inline: false.
	self var: #m1 declareC:'float *m1'.
	self var: #m2 declareC:'float *m2'.
	self var: #m3 declareC:'float *m3'.

	m3 := self stackMatrix: 0.
	m2 := self stackMatrix: 1.
	m1 := self stackMatrix: 2.
	(m1 = nil) | (m2 = nil) | (m3 = nil) 
		ifTrue:[^interpreterProxy primitiveFail].
	m2 == m3 ifTrue:[^interpreterProxy primitiveFail].
	self transformMatrix: m1 with: m2 into: m3.
	interpreterProxy pop: 3. "Leave rcvr on stack"! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 9/18/2002 16:53'!
b3dTransformPoint
	| x y z rx ry rz rw matrix vertex v3Oop |
	self export: true.

	self var: #vertex declareC:'float *vertex'.
	self var: #matrix declareC:'float *matrix'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #z declareC:'double z'.
	self var: #rx declareC:'double rx'.
	self var: #ry declareC:'double ry'.
	self var: #rz declareC:'double rz'.
	self var: #rw declareC:'double rw'.

	interpreterProxy methodArgumentCount = 1
		ifFalse:[^interpreterProxy primitiveFail].
	v3Oop := interpreterProxy stackObjectValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	((interpreterProxy isWords: v3Oop) and:[(interpreterProxy slotSizeOf: v3Oop) = 3])
		ifFalse:[^interpreterProxy primitiveFail].
	vertex := interpreterProxy firstIndexableField: v3Oop.
	matrix := self stackMatrix: 1.
	(matrix == nil) ifTrue:[^interpreterProxy primitiveFail].

	x := vertex at: 0.
	y := vertex at: 1.
	z := vertex at: 2.

	rx := (x * (matrix at: 0)) + (y * (matrix at: 1)) + (z * (matrix at: 2)) + (matrix at: 3).
	ry := (x * (matrix at: 4)) + (y * (matrix at: 5)) + (z * (matrix at: 6)) + (matrix at: 7).
	rz := (x * (matrix at: 8)) + (y * (matrix at: 9)) + (z * (matrix at: 10)) + (matrix at: 11).
	rw := (x * (matrix at: 12)) + (y * (matrix at: 13)) + (z * (matrix at: 14)) + (matrix at: 15).

	v3Oop := interpreterProxy clone: v3Oop.
	vertex := interpreterProxy firstIndexableField: v3Oop.

	rw = 1.0 ifTrue:[
		vertex at: 0 put: (self cCoerce: rx to: 'float').
		vertex at: 1 put: (self cCoerce: ry to:'float').
		vertex at: 2 put: (self cCoerce: rz to: 'float').
	] ifFalse:[
		rw = 0.0 
			ifTrue:[rw := 0.0]
			ifFalse:[rw := 1.0 / rw].
		vertex at: 0 put: (self cCoerce: rx*rw to:'float').
		vertex at: 1 put: (self cCoerce: ry*rw to:'float').
		vertex at: 2 put: (self cCoerce: rz*rw to: 'float').
	].
	interpreterProxy pop: 2.
	interpreterProxy push: v3Oop.
! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 2/14/1999 00:03'!
b3dTransformPrimitiveNormal
	"Transform the normal of the given primitive vertex using the argument matrix and rescale the normal if necessary."
	| pVertex matrix rescale |
	self export: true.
	self inline: false.
	self var: #matrix declareC:'float *matrix'.
	self var: #pVertex declareC:'float *pVertex'.

	rescale := interpreterProxy stackValue: 0.
	rescale == interpreterProxy nilObject 
		ifFalse:[rescale := interpreterProxy booleanValueOf: rescale].
	matrix := self stackMatrix: 1.
	pVertex := self stackPrimitiveVertex: 2.
	(matrix = nil) | (pVertex = nil) 
		ifTrue:[^interpreterProxy primitiveFail].
	(rescale ~~ true and:[rescale ~~ false])
		ifTrue:[rescale := self analyzeMatrix3x3Length: matrix].
	self transformPrimitiveNormal: pVertex by: matrix rescale: rescale.
	interpreterProxy pop: 3. "Leave rcvr on stack"! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 2/14/1999 00:03'!
b3dTransformPrimitivePosition
	"Transform the position of the given primitive vertex the given matrix
	and store the result back inplace."
	| pVertex matrix |
	self export: true.
	self inline: false.
	self var: #matrix declareC:'float *matrix'.
	self var: #pVertex declareC:'float *pVertex'.

	matrix := self stackMatrix: 0.
	pVertex := self stackPrimitiveVertex: 1.
	(matrix = nil) | (pVertex = nil) 
		ifTrue:[^interpreterProxy primitiveFail].
	self transformPrimitivePosition: pVertex by: matrix.
	interpreterProxy pop: 2. "Leave rcvr on stack"! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 2/14/1999 00:03'!
b3dTransformPrimitiveRasterPosition
	"Transform the position of the given primitive vertex the given matrix
	and store the result in homogenous coordinates at rasterPos."
	| pVertex matrix |
	self export: true.
	self inline: false.
	self var: #matrix declareC:'float *matrix'.
	self var: #pVertex declareC:'float *pVertex'.

	matrix := self stackMatrix: 0.
	pVertex := self stackPrimitiveVertex: 1.
	(matrix = nil) | (pVertex = nil) 
		ifTrue:[^interpreterProxy primitiveFail].
	self transformPrimitiveRasterPosition: pVertex by: matrix.
	interpreterProxy pop: 2. "Leave rcvr on stack"! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 2/14/1999 00:05'!
b3dTransformVertexBuffer
	"Transform an entire vertex buffer using the supplied modelview and projection matrix."
	| flags projectionMatrix modelViewMatrix vtxCount vtxArray |
	self export: true.
	self inline: false.
	self var: #projectionMatrix declareC:'float *projectionMatrix'.
	self var: #modelViewMatrix declareC:'float *modelViewMatrix'.
	self var: #vtxArray declareC:'float *vtxArray'.

	flags := interpreterProxy stackIntegerValue: 0.
	projectionMatrix := self stackMatrix: 1.
	modelViewMatrix := self stackMatrix: 2.
	vtxCount := interpreterProxy stackIntegerValue: 3.
	vtxArray := self stackPrimitiveVertexArray: 4 ofSize: vtxCount.
	(projectionMatrix = nil) | (modelViewMatrix = nil) | (vtxArray = nil)
		ifTrue:[^interpreterProxy primitiveFail].
	interpreterProxy failed ifTrue:[^nil].
	self transformVB: vtxArray 
		count: vtxCount 
		by: modelViewMatrix 
		and: projectionMatrix 
		flags: flags.
	interpreterProxy pop: 5. "Leave rcvr on stack"! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 2/17/1999 04:31'!
b3dTransformerVersion
	"Return the current version of the transformer"
	self export: true.
	self inline: false.
	interpreterProxy pop: 1.
	interpreterProxy pushInteger: 1.	"Version 1"! !

!B3DTransformerPlugin methodsFor: 'primitives' stamp: 'ar 9/18/2002 17:33'!
b3dTransposeMatrix
	| srcOop dstOop src dst |
	self export: true.
	self var: #src declareC:'float *src'.
	self var: #dst declareC:'float *dst'.

	interpreterProxy methodArgumentCount = 0
		ifFalse:[^interpreterProxy primitiveFail].
	srcOop := interpreterProxy stackObjectValue: 0.
	interpreterProxy failed ifTrue:[^nil].
	((interpreterProxy isWords: srcOop) and:[(interpreterProxy slotSizeOf: srcOop) = 16])
		ifFalse:[^interpreterProxy primitiveFail].
	dstOop := interpreterProxy clone: srcOop.
	"reload srcOop in case of GC"
	srcOop := interpreterProxy stackObjectValue: 0.
	src := interpreterProxy firstIndexableField: srcOop.
	dst := interpreterProxy firstIndexableField: dstOop.

	"dst at: 0 put: (src at: 0)."
	dst at: 1 put: (src at: 4). 
	dst at: 2 put: (src at: 8). 
	dst at: 3 put: (src at: 12).

	dst at: 4 put: (src at: 1). 
	"dst at: 5 put: (src at: 5)."
	dst at: 6 put: (src at: 9). 
	dst at: 7 put: (src at: 13).

	dst at: 8 put: (src at: 2). 
	dst at: 9 put: (src at: 6). 
	"dst at: 10 put: (src at: 10)."
	dst at: 11 put: (src at: 14).

	dst at: 12 put: (src at: 3). 
	dst at: 13 put: (src at: 7). 
	dst at: 14 put: (src at: 11). 
	"dst at: 15 put: (src at: 15)."

	interpreterProxy pop: 1.
	interpreterProxy push: dstOop.
! !

!B3DTransformerPlugin methodsFor: 'transforming' stamp: 'ar 2/13/1999 23:45'!
transformMatrix: src with: arg into: dst
	"Transform src with arg into dst.
	It is allowed that src == dst but not arg == dst"
	| m1 m2 m3 c1 c2 c3 c4 |
	self var: #src declareC:'float *src'.
	self var: #arg declareC:'float *arg'.
	self var: #dst declareC:'float *dst'.
	self var: #m1 declareC:'float *m1'.
	self var: #m2 declareC:'float *m2'.
	self var: #m3 declareC:'float *m3'.
	self var: #c1 declareC:'float c1'.
	self var: #c2 declareC:'float c2'.
	self var: #c3 declareC:'float c3'.
	self var: #c4 declareC:'float c4'.

	m1 := self cCoerce: src to:'float *'.
	m2 := self cCoerce: arg to: 'float *'.
	m3 := self cCoerce: dst to: 'float *'.

	0 to: 3 do:[:i|

		"Compute next row"
		c1 := ((m1 at: 0) * (m2 at: 0)) + ((m1 at: 1) * (m2 at: 4)) +
				((m1 at: 2) * (m2 at: 8)) + ((m1 at: 3) * (m2 at: 12)).

		c2 := ((m1 at: 0) * (m2 at: 1)) + ((m1 at: 1) * (m2 at: 5)) +
				((m1 at: 2) * (m2 at: 9)) + ((m1 at: 3) * (m2 at: 13)).

		c3 := ((m1 at: 0) * (m2 at: 2)) + ((m1 at: 1) * (m2 at: 6)) +
				((m1 at: 2) * (m2 at: 10)) + ((m1 at: 3) * (m2 at: 14)).

		c4 := ((m1 at: 0) * (m2 at: 3)) + ((m1 at: 1) * (m2 at: 7)) +
				((m1 at: 2) * (m2 at: 11)) + ((m1 at: 3) * (m2 at: 15)).

		"Store result"
		m3 at: 0 put: c1.
		m3 at: 1 put: c2.
		m3 at: 2 put: c3.
		m3 at: 3 put: c4.

		"Skip src and dst to next row"
		m1 := m1 + 4.
		m3 := m3 + 4.
	].
! !

!B3DTransformerPlugin methodsFor: 'transforming' stamp: 'ar 4/17/1999 22:22'!
transformPrimitiveNormal: pVertex by: matrix rescale: rescale
	"Transform the normal of the given primitive vertex"
	| x y z rx ry rz dot |
	self var: #pVertex declareC:'float *pVertex'.
	self var: #matrix declareC:'float *matrix'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #z declareC:'double z'.
	self var: #rx declareC:'double rx'.
	self var: #ry declareC:'double ry'.
	self var: #rz declareC:'double rz'.
	self var: #dot declareC:'double dot'.

	x := pVertex at: PrimVtxNormalX.
	y := pVertex at: PrimVtxNormalY.
	z := pVertex at: PrimVtxNormalZ.

	rx := (x * (matrix at: 0)) + (y * (matrix at: 1)) + (z * (matrix at: 2)).
	ry := (x * (matrix at: 4)) + (y * (matrix at: 5)) + (z * (matrix at: 6)).
	rz := (x * (matrix at: 8)) + (y * (matrix at: 9)) + (z * (matrix at: 10)).

	rescale ifTrue:[
		dot := (rx * rx) + (ry * ry) + (rz * rz).
		dot < 1.0e-20 
			ifTrue:[rx := ry := rz := 0.0]
			ifFalse:[dot = 1.0 ifFalse:[dot := 1.0 / dot sqrt.
									rx := rx * dot. ry := ry * dot. rz := rz * dot]]].

	pVertex at: PrimVtxNormalX put: (self cCoerce: rx to:'float').
	pVertex at: PrimVtxNormalY put: (self cCoerce: ry to:'float').
	pVertex at: PrimVtxNormalZ put: (self cCoerce: rz to:'float').
! !

!B3DTransformerPlugin methodsFor: 'transforming' stamp: 'ar 4/17/1999 22:24'!
transformPrimitivePosition: pVertex by: matrix
	"Transform the normal of the given primitive vertex"
	| x y z rx ry rz rw |
	self var: #pVertex declareC:'float *pVertex'.
	self var: #matrix declareC:'float *matrix'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #z declareC:'double z'.
	self var: #rx declareC:'double rx'.
	self var: #ry declareC:'double ry'.
	self var: #rz declareC:'double rz'.
	self var: #rw declareC:'double rw'.

	x := pVertex at: PrimVtxPositionX.
	y := pVertex at: PrimVtxPositionY.
	z := pVertex at: PrimVtxPositionZ.

	rx := (x * (matrix at: 0)) + (y * (matrix at: 1)) + (z * (matrix at: 2)) + (matrix at: 3).
	ry := (x * (matrix at: 4)) + (y * (matrix at: 5)) + (z * (matrix at: 6)) + (matrix at: 7).
	rz := (x * (matrix at: 8)) + (y * (matrix at: 9)) + (z * (matrix at: 10)) + (matrix at: 11).
	rw := (x * (matrix at: 12)) + (y * (matrix at: 13)) + (z * (matrix at: 14)) + (matrix at: 15).

	rw = 1.0 ifTrue:[
		pVertex at: PrimVtxPositionX put: (self cCoerce: rx to: 'float').
		pVertex at: PrimVtxPositionY put: (self cCoerce: ry to:'float').
		pVertex at: PrimVtxPositionZ put: (self cCoerce: rz to: 'float').
	] ifFalse:[
		rw = 0.0 
			ifTrue:[rw := 0.0]
			ifFalse:[rw := 1.0 / rw].
		pVertex at: PrimVtxPositionX put: (self cCoerce: rx*rw to:'float').
		pVertex at: PrimVtxPositionY put: (self cCoerce: ry*rw to:'float').
		pVertex at: PrimVtxPositionZ put: (self cCoerce: rz*rw to: 'float').
	].
! !

!B3DTransformerPlugin methodsFor: 'transforming' stamp: 'ar 4/17/1999 22:24'!
transformPrimitivePositionFast: pVertex by: matrix
	"Transform the position of the given primitive vertex assuming that 
	matrix a41 = a42 = a43 = 0.0 and a44 = 1.0"
	| x y z rx ry rz |
	self var: #pVertex declareC:'float *pVertex'.
	self var: #matrix declareC:'float *matrix'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #z declareC:'double z'.
	self var: #rx declareC:'double rx'.
	self var: #ry declareC:'double ry'.
	self var: #rz declareC:'double rz'.

	x := pVertex at: PrimVtxPositionX.
	y := pVertex at: PrimVtxPositionY.
	z := pVertex at: PrimVtxPositionZ.

	rx := (x * (matrix at: 0)) + (y * (matrix at: 1)) + (z * (matrix at: 2)) + (matrix at: 3).
	ry := (x * (matrix at: 4)) + (y * (matrix at: 5)) + (z * (matrix at: 6)) + (matrix at: 7).
	rz := (x * (matrix at: 8)) + (y * (matrix at: 9)) + (z * (matrix at: 10)) + (matrix at: 11).

	pVertex at: PrimVtxPositionX put: (self cCoerce: rx to: 'float').
	pVertex at: PrimVtxPositionY put: (self cCoerce: ry to: 'float').
	pVertex at: PrimVtxPositionZ put: (self cCoerce: rz to: 'float').! !

!B3DTransformerPlugin methodsFor: 'transforming' stamp: 'ar 4/17/1999 22:25'!
transformPrimitivePositionFaster: pVertex by: matrix
	"Transform the position of the given primitive vertex assuming that 
	matrix a14 = a24 = a34 = a41 = a42 = a43 = 0.0 and a44 = 1.0"
	| x y z rx ry rz |
	self var: #pVertex declareC:'float *pVertex'.
	self var: #matrix declareC:'float *matrix'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #z declareC:'double z'.
	self var: #rx declareC:'double rx'.
	self var: #ry declareC:'double ry'.
	self var: #rz declareC:'double rz'.

	x := pVertex at: PrimVtxPositionX.
	y := pVertex at: PrimVtxPositionY.
	z := pVertex at: PrimVtxPositionZ.

	rx := (x * (matrix at: 0)) + (y * (matrix at: 1)) + (z * (matrix at: 2)).
	ry := (x * (matrix at: 4)) + (y * (matrix at: 5)) + (z * (matrix at: 6)).
	rz := (x * (matrix at: 8)) + (y * (matrix at: 9)) + (z * (matrix at: 10)).

	pVertex at: PrimVtxPositionX put: (self cCoerce: rx to:'float').
	pVertex at: PrimVtxPositionY put: (self cCoerce: ry to:'float').
	pVertex at: PrimVtxPositionZ put: (self cCoerce: rz to: 'float').! !

!B3DTransformerPlugin methodsFor: 'transforming' stamp: 'ar 4/17/1999 22:26'!
transformPrimitiveRasterPosition: pVertex by: matrix
	"Transform the normal of the given primitive vertex"
	| x y z rx ry rz rw |
	self var: #pVertex declareC:'float *pVertex'.
	self var: #matrix declareC:'float *matrix'.
	self var: #x declareC:'double x'.
	self var: #y declareC:'double y'.
	self var: #z declareC:'double z'.
	self var: #rx declareC:'double rx'.
	self var: #ry declareC:'double ry'.
	self var: #rz declareC:'double rz'.
	self var: #rw declareC:'double rw'.

	x := pVertex at: PrimVtxPositionX.
	y := pVertex at: PrimVtxPositionY.
	z := pVertex at: PrimVtxPositionZ.

	rx := (x * (matrix at: 0)) + (y * (matrix at: 1)) + (z * (matrix at: 2)) + (matrix at: 3).
	ry := (x * (matrix at: 4)) + (y * (matrix at: 5)) + (z * (matrix at: 6)) + (matrix at: 7).
	rz := (x * (matrix at: 8)) + (y * (matrix at: 9)) + (z * (matrix at: 10)) + (matrix at: 11).
	rw := (x * (matrix at: 12)) + (y * (matrix at: 13)) + (z * (matrix at: 14)) + (matrix at: 15).

	pVertex at: PrimVtxRasterPosX put: (self cCoerce: rx to:'float').
	pVertex at: PrimVtxRasterPosY put: (self cCoerce: ry to:'float').
	pVertex at: PrimVtxRasterPosZ put: (self cCoerce: rz to:'float').
	pVertex at: PrimVtxRasterPosW put: (self cCoerce: rw to:'float').
! !

!B3DTransformerPlugin methodsFor: 'transforming' stamp: 'ar 2/13/1999 23:47'!
transformVB: vtxArray count: vtxCount by: modelViewMatrix and: projectionMatrix flags: flags
	"Transform the entire vertex array by the given matrices"
	"TODO: Check the actual trade-offs between vtxCount and analyzing"
	| mvFlags prFlags pVertex hasNormals rescale |
	self var: #projectionMatrix declareC:'float *projectionMatrix'.
	self var: #modelViewMatrix declareC:'float *modelViewMatrix'.
	self var: #vtxArray declareC:'float *vtxArray'.
	self var: #pVertex declareC:'float *pVertex'.

	"Analyze the matrices for better performance"
	mvFlags := self analyzeMatrix: modelViewMatrix.
	prFlags := self analyzeMatrix: projectionMatrix.

	pVertex := self cCoerce: vtxArray to: 'float *'.
	hasNormals := flags anyMask: VBVtxHasNormals.

	"Check if we have to rescale the normals"
	hasNormals ifTrue:[
		(mvFlags anyMask: FlagM44Identity)
			ifTrue:[rescale := false]
			ifFalse:[rescale := self analyzeMatrix3x3Length: modelViewMatrix]].

	"<---- NOTE: The most likely case goes first ---->"
	((mvFlags anyMask: FlagM44NoPerspective) and:[prFlags = 0]) ifTrue:[
		"Modelview matrix has no perspective part and projection is not optimized"
		(mvFlags = FlagM44NoTranslation) = 0 ifTrue:[
			"Modelview matrix with translation"
			1 to: vtxCount do:[:i|
				hasNormals ifTrue:[self transformPrimitiveNormal: pVertex by: modelViewMatrix rescale: rescale].
				self transformPrimitivePositionFast: pVertex by: modelViewMatrix.
				self transformPrimitiveRasterPosition: pVertex by: projectionMatrix.
				pVertex := pVertex + PrimVertexSize].
		] ifFalse:[
			"Modelview matrix without translation"
			1 to: vtxCount do:[:i|
				hasNormals ifTrue:[self transformPrimitiveNormal: pVertex by: modelViewMatrix rescale: rescale].
				self transformPrimitivePositionFaster: pVertex by: modelViewMatrix.
				self transformPrimitiveRasterPosition: pVertex by: projectionMatrix.
				pVertex := pVertex + PrimVertexSize].
		].
		^nil]. "done"
	"<---- End of most likely case ---->"

	((mvFlags bitAnd: prFlags) anyMask: FlagM44Identity) ifTrue:[
		"If both are identity matrices just copy entries"
		1 to: vtxCount do:[:i|
			pVertex at: PrimVtxRasterPosX put: (pVertex at: PrimVtxPositionX).
			pVertex at: PrimVtxRasterPosY put: (pVertex at: PrimVtxPositionY).
			pVertex at: PrimVtxRasterPosZ put: (pVertex at: PrimVtxPositionZ).
			pVertex at: PrimVtxRasterPosW put: 1.0.
			pVertex := pVertex + PrimVertexSize].
		^nil]."done"

	(mvFlags anyMask: FlagM44Identity) ifTrue:[
		"If model view matrix is identity just perform projection"
		1 to: vtxCount do:[:i|
			self transformPrimitiveRasterPosition: pVertex by: projectionMatrix.
			pVertex := pVertex + PrimVertexSize].
		^nil]. "done"

	"<--- modelview matrix not identity --->"

	(prFlags anyMask: FlagM44Identity) ifTrue:[
		"If projection matrix is identity just transform and copy.
		Note: This case is not very likely so it's not been unrolled."
		1 to: vtxCount do:[:i|
			hasNormals ifTrue:[self transformPrimitiveNormal: pVertex by: modelViewMatrix rescale: rescale].
			mvFlags = (FlagM44NoPerspective + FlagM44NoPerspective) ifTrue:[
				self transformPrimitivePositionFaster: pVertex by: modelViewMatrix.
			] ifFalse:[mvFlags = FlagM44NoPerspective ifTrue:[
				self transformPrimitivePositionFast: pVertex by: modelViewMatrix.
			] ifFalse:[
				self transformPrimitivePosition: pVertex by: modelViewMatrix.
			]].
			pVertex at: PrimVtxRasterPosX put: (pVertex at: PrimVtxPositionX).
			pVertex at: PrimVtxRasterPosY put: (pVertex at: PrimVtxPositionY).
			pVertex at: PrimVtxRasterPosZ put: (pVertex at: PrimVtxPositionZ).
			pVertex at: PrimVtxRasterPosW put: 1.0.
			pVertex := pVertex + PrimVertexSize].
		^nil]. "done"

	"<----- None of the matrices is identity ---->"

	"Generic transformation"
	1 to: vtxCount do:[:i|
		hasNormals ifTrue:[self transformPrimitiveNormal: pVertex by: modelViewMatrix rescale: rescale].
		self transformPrimitivePosition: pVertex by: modelViewMatrix.
		self transformPrimitiveRasterPosition: pVertex by: projectionMatrix.
		pVertex := pVertex + PrimVertexSize].! !

B3DEnginePlugin subclass: #B3DVertexBufferPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins'!

!B3DVertexBufferPlugin methodsFor: 'primitives' stamp: 'ar 2/14/1999 23:32'!
b3dLoadIndexArray
	"Primitive. Load the given index array into the receiver.
	NOTE: dstStart is a zero-based index."
	| vtxOffset maxValue count srcArray srcPtr idx dstStart dstArray dstSize dstPtr |
	self export: true.
	self inline: false.
	self var: #dstPtr declareC:'int *dstPtr'.
	self var: #srcPtr declareC:'int *srcPtr'.
	"Load the arguments"
	vtxOffset := interpreterProxy stackIntegerValue: 0.
	maxValue := interpreterProxy stackIntegerValue: 1.
	count := interpreterProxy stackIntegerValue: 2.
	srcArray := interpreterProxy stackObjectValue: 3.
	dstStart := interpreterProxy stackIntegerValue: 4.
	dstArray := interpreterProxy stackObjectValue: 5.
	interpreterProxy failed ifTrue:[^nil]. "Will cover all possible problems above"
	"Check srcArray"
	(interpreterProxy isWords: srcArray)
		ifFalse:[^interpreterProxy primitiveFail].
	((interpreterProxy slotSizeOf: srcArray) < count)
		ifTrue:[^interpreterProxy primitiveFail].
	srcPtr := self cCoerce: (interpreterProxy firstIndexableField: srcArray) to:'int*'.
	"Check dstArray"
 	dstSize := interpreterProxy slotSizeOf: dstArray.
	"Check if there is enough room left in dstArray"
	dstStart + count > dstSize
		ifTrue:[^interpreterProxy primitiveFail].
	dstPtr := self cCoerce: (interpreterProxy firstIndexableField: dstArray) to:'int *'.
	"Do the actual work"
	0 to: count-1 do:[:i|
		idx := srcPtr at: i.
		(idx < 1 or:[idx > maxValue]) 
			ifTrue:[^interpreterProxy primitiveFail].
		dstPtr at: dstStart + i put: idx + vtxOffset.
	].
	"Clean up the stack"
	interpreterProxy pop: 7. "Pop args+rcvr"
	interpreterProxy pushInteger: count.
! !

!B3DVertexBufferPlugin methodsFor: 'primitives' stamp: 'ar 11/20/2000 22:48'!
b3dLoadVertexBuffer
	"Primitive. Load the data into the given vertex buffer.
	NOTE: dstStart is a zero-based index."
	| defaultVtx defaultNormal defaultTexCoords defaultColor count texPtr colorPtr normalPtr vtxPtr dstStart dstPtr pVtx |

	self export: true.
	self inline: false.

	self var: #defaultVtx declareC:'int *defaultVtx'.
	self var: #defaultNormal declareC:'int *defaultNormal'.
	self var: #defaultTexCoords declareC:'int *defaultTexCoords'.
	self var: #defaultColor declareC:'int *defaultColor'.

	self var: #texPtr declareC:'int *texPtr'.
	self var: #colorPtr declareC:'int *colorPtr'.
	self var: #normalPtr declareC:'int *normalPtr'.
	self var: #vtxPtr declareC:'int *vtxPtr'.
	self var: #dstPtr declareC:'int *dstPtr'.
	self var: #pVtx declareC:'int *pVtx'.

	defaultVtx := self stackPrimitiveVertex: 0.
	count := interpreterProxy stackIntegerValue: 1.
	texPtr := self vbLoadArray: (interpreterProxy stackObjectValue: 2) 
				size: 2*count.
	colorPtr := self vbLoadArray: (interpreterProxy stackObjectValue: 3) 
				size: count.
	normalPtr := self vbLoadArray: (interpreterProxy stackObjectValue: 4) 
				size: 3*count.
	vtxPtr := self vbLoadArray: (interpreterProxy stackObjectValue: 5) 
				size: 3*count.
	dstStart := interpreterProxy stackIntegerValue: 6.
	dstPtr := self stackPrimitiveVertexArray: 7 ofSize: dstStart + count.
	"Check for all problems above"
	(dstPtr = nil or:[defaultVtx == nil or:[interpreterProxy failed]]) 
		ifTrue:[^interpreterProxy primitiveFail].

	"Install default values"
	normalPtr = nil
		ifTrue:[defaultNormal := defaultVtx + PrimVtxNormal]
		ifFalse:[defaultNormal := normalPtr].
	texPtr = nil
		ifTrue:[defaultTexCoords := defaultVtx + PrimVtxTexCoords]
		ifFalse:[defaultTexCoords := texPtr].
	colorPtr = nil
		ifTrue:[defaultColor := defaultVtx + PrimVtxColor32]
		ifFalse:[defaultColor := colorPtr].
	"Do the actual stuff"
	pVtx := dstPtr + (dstStart * PrimVertexSize).
	0 to: count-1 do:[:i|
		pVtx at: PrimVtxPositionX put: (vtxPtr at: 0).
		pVtx at: PrimVtxPositionY put: (vtxPtr at: 1).
		pVtx at: PrimVtxPositionZ put: (vtxPtr at: 2).
		pVtx at: PrimVtxNormalX put: (defaultNormal at: 0).
		pVtx at: PrimVtxNormalY put: (defaultNormal at: 1).
		pVtx at: PrimVtxNormalZ put: (defaultNormal at: 2).
		pVtx at: PrimVtxColor32 put: (defaultColor at: 0).
		pVtx at: PrimVtxTexCoordU put: (defaultTexCoords at: 0).
		pVtx at: PrimVtxTexCoordV put: (defaultTexCoords at: 1).
		"And go to the next vertex"
		pVtx := pVtx + PrimVertexSize.
		vtxPtr := vtxPtr + 3.
		normalPtr = nil ifFalse:[defaultNormal := defaultNormal + 3].
		colorPtr = nil ifFalse:[defaultColor := defaultColor + 1].
		texPtr = nil ifFalse:[defaultTexCoords := defaultTexCoords + 2].
	].
	"Clean up stack"
	interpreterProxy pop: 9. "Pop args+rcvr"
	interpreterProxy pushInteger: count.! !

!B3DVertexBufferPlugin methodsFor: 'private' stamp: 'ar 4/17/1999 22:29'!
vbLoadArray: oop size: count
	"Load the word based array of size count from the given oop"
	self returnTypeC: 'void*'.
	self inline: false.
	oop == nil ifTrue:[interpreterProxy primitiveFail. ^nil].
	oop == interpreterProxy nilObject ifTrue:[^nil].
	(interpreterProxy isWords: oop) 
		ifFalse:[interpreterProxy primitiveFail. ^nil].
	(interpreterProxy slotSizeOf: oop) = count
		ifFalse:[interpreterProxy primitiveFail. ^nil].
	^interpreterProxy firstIndexableField: oop! !

Object subclass: #B3DActiveEdgeTable
	instanceVariableNames: 'start stop array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins-Simulator'!

!B3DActiveEdgeTable class methodsFor: 'instance creation' stamp: 'ar 3/4/2004 22:57'!
new
	^self basicNew initialize! !

!B3DActiveEdgeTable methodsFor: 'private' stamp: 'ar 4/5/1999 02:19'!
asArray
	^array copyFrom: 1 to: stop! !

!B3DActiveEdgeTable methodsFor: 'accessing' stamp: 'ar 4/6/1999 02:21'!
at: index
	^array at: index! !

!B3DActiveEdgeTable methodsFor: 'streaming' stamp: 'ar 4/3/1999 05:28'!
atEnd
	^start >= stop! !

!B3DActiveEdgeTable methodsFor: 'enumerating' stamp: 'ar 4/5/1999 02:19'!
do: aBlock
	1 to: stop do:[:i| aBlock value: (array at: i)].! !

!B3DActiveEdgeTable methodsFor: 'accessing' stamp: 'ar 4/18/1999 05:48'!
first
	^array at: 1! !

!B3DActiveEdgeTable methodsFor: 'private' stamp: 'ar 4/3/1999 05:25'!
grow
	| newArray |
	newArray := array species new: array size + 100. "Grow linearly"
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray.! !

!B3DActiveEdgeTable methodsFor: 'accessing' stamp: 'ar 4/6/1999 23:20'!
indexOf: anEdge
	1 to: stop do:[:i| (array at: i) = anEdge ifTrue:[^i]].
	^0! !

!B3DActiveEdgeTable methodsFor: 'initialize' stamp: 'ar 4/4/1999 20:55'!
initialize
	array := Array new: 100.
	start := 0.
	stop := 0.! !

!B3DActiveEdgeTable methodsFor: 'testing' stamp: 'ar 4/4/1999 21:21'!
isEmpty
	^stop = 0! !

!B3DActiveEdgeTable methodsFor: 'accessing' stamp: 'ar 4/18/1999 05:48'!
last
	^array at: stop! !

!B3DActiveEdgeTable methodsFor: 'merging' stamp: 'ar 4/4/1999 21:52'!
mergeEdgesFrom: inputList
	"Merge all the edges from the given input list in the AET"
	| srcIndex dstIndex outIndex srcEdge dstEdge |
	srcIndex := inputList size.
	srcIndex = 0 ifTrue:[^self].
	dstIndex := stop.
	"Make room for adding the stuff"
	[stop + srcIndex > array size] whileTrue:[self grow].
	"Adjust size"
	stop := stop + srcIndex.
	"If the receiver is empty, simply copy the stuff"
	dstIndex = 0 ifTrue:[
		1 to: srcIndex do:[:i| array at: i put: (inputList at: i)].
		^self].
	"Merge inputList by walking backwards through the AET and checking each edge."
	outIndex := dstIndex+srcIndex.
	srcEdge := inputList at: srcIndex.
	dstEdge := array at: dstIndex.
	[true] whileTrue:[
		srcEdge xValue >= dstEdge xValue ifTrue:[
			"Insert srcEdge"
			array at: outIndex put: srcEdge.
			srcIndex := srcIndex - 1.
			srcIndex = 0 ifTrue:[^self].
			srcEdge := inputList at: srcIndex.
		] ifFalse:[
			"Insert dstEdge"
			array at: outIndex put: dstEdge.
			dstIndex := dstIndex - 1.
			dstIndex = 0 ifTrue:[
				1 to: srcIndex do:[:i| array at: i put: (inputList at: i)].
				^self].
			dstEdge := array at: dstIndex.
		].
		outIndex := outIndex-1.
	].! !

!B3DActiveEdgeTable methodsFor: 'streaming' stamp: 'ar 4/3/1999 05:28'!
next
	"Return the next entry from the AET and advance start"
	^array at: (start := start + 1)! !

!B3DActiveEdgeTable methodsFor: 'streaming' stamp: 'ar 4/5/1999 23:24'!
peek
	"Peek the next entry from the AET"
	^array at: (start + 1)! !

!B3DActiveEdgeTable methodsFor: 'removing' stamp: 'ar 4/5/1999 03:15'!
removeFirst
	stop := stop - 1.
	array replaceFrom: start to: stop with: array startingAt: start+1.
	start := start - 1.
	array at: stop+1 put: nil.! !

!B3DActiveEdgeTable methodsFor: 'streaming' stamp: 'ar 4/3/1999 05:28'!
reset
	start := 0.! !

!B3DActiveEdgeTable methodsFor: 'sorting' stamp: 'ar 4/3/1999 05:27'!
resortFirst
	"Resort the first entry in the active edge table"
	| edge xValue leftEdge newIndex |
	start = 1 ifTrue:[^self]. "Nothing to do"
	"Fetch the edge to test."
	edge := array at: start.
	xValue := edge xValue.
	"Fetch the next edge left to it."
	leftEdge := array at: start-1.
	leftEdge xValue <= xValue ifTrue:[^self]. "Okay."
	"Move the edge left to its correct insertion point."
	newIndex := start.
	[newIndex > 1 and:[(leftEdge := array at: newIndex-1) xValue > xValue]]
		whileTrue:[	array at: newIndex put: leftEdge.
					newIndex := newIndex - 1].
	array at: newIndex put: edge.! !

!B3DActiveEdgeTable methodsFor: 'accessing' stamp: 'ar 4/3/1999 05:28'!
size
	^stop! !

!B3DActiveEdgeTable methodsFor: 'accessing' stamp: 'ar 4/6/1999 03:51'!
xValues
	^(array copyFrom: 1 to: stop) collect:[:e| e xValue]! !

Object subclass: #B3DFillList
	instanceVariableNames: 'firstFace lastFace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins-Simulator'!

!B3DFillList class methodsFor: 'instance creation' stamp: 'ar 3/4/2004 22:59'!
new
	^self basicNew initialize! !

!B3DFillList methodsFor: 'adding' stamp: 'ar 4/5/1999 20:38'!
addBack: aFace
	"Add the given face as a non-front face (e.g., insert it after the front face).
	Make sure that the receiver stays sorted by the minimal z values of faces."
	| minZ midZ face |
	firstFace == nil ifTrue:[^self error:'Inserting a back face with no front face'].
	minZ := aFace minZ.
	"Quick optimization for insertion at end"
	(firstFace == lastFace or:[minZ >= lastFace minZ]) ifTrue:[^self addLast: aFace].
	"Try an estimation for how to search"
	midZ := (firstFace nextFace minZ + lastFace minZ) * 0.5.
	minZ <= midZ ifTrue:[
		"Search front to back"
		face := firstFace nextFace.
		[face minZ < minZ] whileTrue:[face := face nextFace].
	] ifFalse:[
		"Search back to front"
		face := lastFace prevFace. "Already checked for lastFace minZ < face minZ"
		[face minZ > minZ] whileTrue:[face := face prevFace].
		face := face nextFace.
	].
	self insert: aFace before: face.! !

!B3DFillList methodsFor: 'adding' stamp: 'ar 4/18/1999 08:04'!
addFirst: aFace
	firstFace isNil
		ifTrue:[lastFace := aFace]
		ifFalse:[firstFace prevFace: aFace].
	aFace nextFace: firstFace.
	aFace prevFace: nil.
	firstFace := aFace.
	B3DScanner doDebug ifTrue:[self validate].! !

!B3DFillList methodsFor: 'adding' stamp: 'ar 4/5/1999 20:41'!
addFront: aFace
	"Add the given face as the new front face.
	Make sure the sort order stays okay."
	| backFace minZ tempFace |
	firstFace == lastFace ifFalse:["firstFace == lastFace denotes 0 or 1 elements"
		backFace := firstFace nextFace.
		minZ := firstFace minZ.
		[backFace notNil and:[backFace minZ < minZ]] 
			whileTrue:[backFace := backFace nextFace].
		"backFace contains the face before which firstFace has to be added"
		firstFace nextFace == backFace ifFalse:[
			tempFace := firstFace.
			self remove: tempFace.
			backFace == nil 
				ifTrue:[self addLast: tempFace]
				ifFalse:[self insert: tempFace before: backFace].
		].
	].
	^self addFirst: aFace! !

!B3DFillList methodsFor: 'adding' stamp: 'ar 4/18/1999 08:04'!
addLast: aFace
	lastFace isNil
		ifTrue:[firstFace := aFace]
		ifFalse:[lastFace nextFace: aFace].
	aFace prevFace: lastFace.
	aFace nextFace: nil.
	lastFace := aFace.
	B3DScanner doDebug ifTrue:[self validate].! !

!B3DFillList methodsFor: 'enumerating' stamp: 'ar 4/18/1999 08:03'!
do: aBlock
	| face |
	B3DScanner doDebug ifTrue:[self validate].
	face := firstFace.
	[face == nil] whileFalse:[
		aBlock value: face.
		face := face nextFace.
	].! !

!B3DFillList methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:39'!
first
	^firstFace! !

!B3DFillList methodsFor: 'testing' stamp: 'ar 4/5/1999 01:58'!
includes: aFace
	| face |
	face := firstFace.
	[face == nil] whileFalse:[
		face == aFace ifTrue:[^true].
		face := face nextFace.
	].
	^false! !

!B3DFillList methodsFor: 'initialize' stamp: 'ar 4/4/1999 04:28'!
initialize
	self reset.! !

!B3DFillList methodsFor: 'adding' stamp: 'ar 4/18/1999 08:04'!
insert: aFace before: nextFace
	"Insert the given face before nextFace."
	B3DScanner doDebug ifTrue:[
		(self includes: nextFace) ifFalse:[^self error:'Face not in collection'].
		(self includes: aFace) ifTrue:[^self error:'Face already in collection'].
	].
	aFace nextFace: nextFace.
	aFace prevFace: nextFace prevFace.
	aFace prevFace nextFace: aFace.
	nextFace prevFace: aFace.
	B3DScanner doDebug ifTrue:[self validate].! !

!B3DFillList methodsFor: 'testing' stamp: 'ar 4/3/1999 00:49'!
isEmpty
	^firstFace == nil! !

!B3DFillList methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:49'!
last
	^lastFace! !

!B3DFillList methodsFor: 'private' stamp: 'ar 4/5/1999 03:54'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut:$(;
		print: self size;
		nextPut: $).! !

!B3DFillList methodsFor: 'removing' stamp: 'ar 4/18/1999 08:04'!
remove: aFace
	(B3DScanner doDebug and:[(self includes: aFace) not]) 
		ifTrue:[^self error:'Face not in list'].
	B3DScanner doDebug ifTrue:[self validate].
	aFace prevFace isNil
		ifTrue:[firstFace := aFace nextFace]
		ifFalse:[aFace prevFace nextFace: aFace nextFace].
	aFace nextFace isNil
		ifTrue:[lastFace := aFace prevFace]
		ifFalse:[aFace nextFace prevFace: aFace prevFace].
	^aFace! !

!B3DFillList methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:31'!
reset
	firstFace := lastFace := nil.! !

!B3DFillList methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:00'!
searchForNewTopAtX: xValue y: yValue
	"A top face ended with no known right face.
	We have to search the fill list for the face with the smallest z value.
	Note: In theory, this should only happen on *right* boundaries of meshes
	and thus not affect performance too much. Having the fillList sorted by
	its minimal z value should help, too."
	| face topFace topZ faceZ floatX floatY |
	self isEmpty ifTrue:[^self]. "No top"
	floatX := xValue / 4096.0.
	floatY := yValue.
	face := self first.
	topFace := face.
	topZ := face zValueAtX: floatX y: floatY.
	[face := face nextFace.
	face == nil] whileFalse:[
		face minZ > topZ ifTrue:[
			"Done. Everything else is behind."
			self remove: topFace.
			self addFront: topFace.
			^self].
		faceZ := face zValueAtX: floatX y: floatY.
		faceZ < topZ ifTrue:[
			topZ := faceZ.
			topFace := face]].
	self remove: topFace.
	self addFront: topFace.! !

!B3DFillList methodsFor: 'accessing' stamp: 'ar 4/4/1999 23:53'!
size
	| n face |
	n := 0.
	face := firstFace.
	[face == nil] whileFalse:[
		n := n + 1.
		face := face nextFace.
	].
	^n! !

!B3DFillList methodsFor: 'private' stamp: 'ar 4/5/1999 20:27'!
validate
	| face |
	(firstFace == nil and:[lastFace == nil]) ifTrue:[^self].
	firstFace prevFace == nil ifFalse:[^self error:'Bad list'].
	lastFace nextFace == nil ifFalse:[^self error:'Bad list'].
	face := firstFace.
	[face == lastFace] whileFalse:[face := face nextFace].
	self validateSortOrder.! !

!B3DFillList methodsFor: 'private' stamp: 'ar 4/5/1999 20:39'!
validateSortOrder
	| backFace |
	firstFace == lastFace ifTrue:[^self]. "0 or 1 element"
	backFace := firstFace nextFace.
	[backFace nextFace == nil] whileFalse:[
		backFace minZ <= backFace nextFace minZ ifFalse:[^self error:'Sorting error'].
		backFace := backFace nextFace.
	].! !

Object subclass: #B3DPrimitiveEdge
	instanceVariableNames: 'v0 v1 leftFace rightFace flags xValue yValue zValue nLines xIncrement zIncrement'
	classVariableNames: 'DepthScale FixedScale FixedToInt'
	poolDictionaries: ''
	category: 'Balloon3D-Plugins-Simulator'!

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/4/1999 02:41'!
flags
	^flags! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/4/1999 02:41'!
flags: aNumber
	flags := aNumber! !

!B3DPrimitiveEdge methodsFor: 'initialize' stamp: 'ar 4/3/1999 04:25'!
from: vtx0 to: vtx1
	(vtx0 sortsBefore: vtx1) 
		ifTrue:[v0 := vtx0. v1 := vtx1]
		ifFalse:[v1 := vtx0. v0 := vtx1].! !

!B3DPrimitiveEdge methodsFor: 'initialize' stamp: 'ar 4/18/1999 08:05'!
initializePass1
	"Assume: v0 sortsBefore: v1"
	xValue := v0 windowPosX.
	yValue := v0 windowPosY.
	zValue := v0 rasterPosZ.
	xIncrement := (v1 windowPosX - v0 windowPosX) // nLines.
	zIncrement := (v1 rasterPosZ - v0 rasterPosZ) / nLines.! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:33'!
leftFace
	^leftFace! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:33'!
leftFace: aFace
	leftFace := aFace! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/3/1999 03:25'!
nLines
	^nLines! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/3/1999 03:25'!
nLines: aNumber
	nLines := aNumber! !

!B3DPrimitiveEdge methodsFor: 'printing' stamp: 'ar 4/4/1999 23:35'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut:$(;
		print: (v0 windowPos bitShiftPoint:-12);
		nextPutAll:' - ';
		print: (v1 windowPos bitShiftPoint: -12);
		nextPutAll:' nLines = ';
		print: nLines;
		nextPut:$).! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:33'!
rightFace
	^rightFace! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:33'!
rightFace: aFace
	rightFace := aFace.! !

!B3DPrimitiveEdge methodsFor: 'processing' stamp: 'ar 4/5/1999 02:45'!
stepToNextLine
	"Step to the next scan line"
	xValue := xValue + xIncrement.
	yValue := yValue + 4096.
	zValue := zValue + zIncrement.! !

!B3DPrimitiveEdge methodsFor: 'initialize' stamp: 'ar 4/4/1999 21:34'!
v0: vtx0 v1: vtx1
	v0 := vtx0.
	v1 := vtx1.
	flags := 0.
	nLines := (vtx1 windowPosY bitShift: -12) - (vtx0 windowPosY bitShift: -12).! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/4/1999 20:58'!
vertex0
	^v0! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/4/1999 20:58'!
vertex1
	^v1! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/6/1999 23:21'!
xIncrement	
	^xIncrement! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:48'!
xValue
	^xValue! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/5/1999 22:25'!
xValue: aNumber
	xValue := aNumber! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:48'!
yValue
	^yValue! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:48'!
zValue
	^zValue! !

!B3DPrimitiveEdge methodsFor: 'accessing' stamp: 'ar 4/6/1999 01:23'!
zValue: aNumber
	zValue := aNumber! !

Object subclass: #B3DPrimitiveEdgeList
	instanceVariableNames: 'tally array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins-Simulator'!

!B3DPrimitiveEdgeList class methodsFor: 'instance creation' stamp: 'ar 3/4/2004 22:59'!
new
	^self basicNew initialize! !

!B3DPrimitiveEdgeList methodsFor: 'adding' stamp: 'ar 4/4/1999 23:44'!
add: edge1 and: edge2 beforeIndex: index
	tally+1 >= array size ifTrue:[self grow].
	tally+2 to: index+2 by: -1 do:[:i|array at: i put: (array at:i-2)].
	"array replaceFrom: index+2 to: tally+2 with: array startingAt: index."
	array at: index put: edge1.
	array at: index+1 put: edge2.
	tally := tally + 2.! !

!B3DPrimitiveEdgeList methodsFor: 'adding' stamp: 'ar 4/4/1999 23:45'!
add: edge beforeIndex: index
	tally = array size ifTrue:[self grow].
	tally+1 to: index+1 by: -1 do:[:i|array at: i put: (array at:i-1)].
	"array replaceFrom: index+1 to: tally+1 with: array startingAt: index."
	array at: index put: edge.
	tally := tally + 1! !

!B3DPrimitiveEdgeList methodsFor: 'accessing' stamp: 'ar 4/4/1999 21:42'!
at: index
	^array at: index! !

!B3DPrimitiveEdgeList methodsFor: 'enumerating' stamp: 'ar 4/5/1999 02:27'!
do: aBlock
	1 to: tally do:[:i| aBlock value: (array at: i)].! !

!B3DPrimitiveEdgeList methodsFor: 'accessing' stamp: 'ar 4/4/1999 21:01'!
first
	^array at: 1! !

!B3DPrimitiveEdgeList methodsFor: 'sorting' stamp: 'ar 4/5/1999 01:41'!
firstIndexForInserting: xValue
	"Return the first possible index for inserting an object with the given xValue"
	| index |
	index := self indexForInserting: xValue.
	[index > 1 and:[(array at: index-1) xValue = xValue]]
		whileTrue:[index := index-1].
	^index! !

!B3DPrimitiveEdgeList methodsFor: 'private' stamp: 'ar 4/4/1999 01:38'!
grow
	| newArray |
	newArray := array species new: array size + 100.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray.! !

!B3DPrimitiveEdgeList methodsFor: 'sorting' stamp: 'ar 4/5/1999 01:41'!
indexForInserting: xValue
	"Return the appropriate index for inserting the given x value"
	| index low high |
	low := 1.
	high := tally.
	[index := high + low // 2.
	low > high]
		whileFalse:[
			(array at: index) xValue <= xValue
				ifTrue: [low := index + 1]
				ifFalse: [high := index - 1]].
	^low! !

!B3DPrimitiveEdgeList methodsFor: 'initialize' stamp: 'ar 4/4/1999 01:38'!
initialize
	array := Array new: 100.
	tally := 0.! !

!B3DPrimitiveEdgeList methodsFor: 'testing' stamp: 'ar 4/4/1999 23:09'!
isEmpty
	^tally = 0! !

!B3DPrimitiveEdgeList methodsFor: 'initialize' stamp: 'ar 4/4/1999 21:20'!
reset
	1 to: tally do:[:i| array at: i put: nil].
	tally := 0.! !

!B3DPrimitiveEdgeList methodsFor: 'accessing' stamp: 'ar 4/4/1999 21:42'!
size
	^tally! !

!B3DPrimitiveEdgeList methodsFor: 'enumerating' stamp: 'ar 4/4/1999 01:39'!
xValue: xValue from: firstIndex do: aBlock
	"Enumerate the entries in the insertion list starting at the given first index.
	Evaluate aBlock with the entries having the requested x value. Return the index
	after the last element touched."
	| edge |
	firstIndex to: tally do:[:i|
		edge := array at: i.
		edge xValue = xValue ifFalse:[^i].
		aBlock value: edge.
	].
	^tally+1! !

!B3DPrimitiveEdgeList methodsFor: 'accessing' stamp: 'ar 4/6/1999 03:58'!
xValues
	^(array copyFrom: 1 to: tally) collect:[:e| e xValue]! !

Object subclass: #B3DPrimitiveFace
	instanceVariableNames: 'v0 v1 v2 prevFace nextFace leftEdge rightEdge flags majorDx majorDy minorDx minorDy oneOverArea dzdx dzdy minZ maxZ texture attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins-Simulator'!

!B3DPrimitiveFace methodsFor: 'processing' stamp: 'ar 4/18/1999 06:34'!
attrValue: attr atX: xValue y: yValue
	"Return the value of the attribute at position xValue@yValue"
	^attr valueAtX: (xValue - v0 rasterPosX) y: (yValue - v0 rasterPosY).! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/6/1999 22:40'!
attributes
	^attributes! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/5/1999 04:13'!
dzdx
	^dzdx! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/5/1999 04:13'!
dzdy
	^dzdy! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:34'!
flags
	^flags! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:34'!
flags: anInteger
	flags := anInteger! !

!B3DPrimitiveFace methodsFor: 'initialize' stamp: 'ar 4/5/1999 18:29'!
initializeDepthBounds
	"Compute minZ/maxZ"
	v0 rasterPosZ <= v1 rasterPosZ ifTrue:[
		v1 rasterPosZ <= v2 rasterPosZ
			ifTrue:[minZ := v0 rasterPosZ. maxZ := v2 rasterPosZ]
			ifFalse:[v0 rasterPosZ <= v2 rasterPosZ
						ifTrue:[minZ := v0 rasterPosZ. maxZ := v1 rasterPosZ]
						ifFalse:[minZ := v2 rasterPosZ. maxZ := v1 rasterPosZ]].
	] ifFalse:[
		v2 rasterPosZ <= v1 rasterPosZ
			ifTrue:[minZ := v2 rasterPosZ. maxZ := v0 rasterPosZ]
			ifFalse:[v0 rasterPosZ <= v2 rasterPosZ
						ifTrue:[minZ := v1 rasterPosZ. maxZ := v2 rasterPosZ]
						ifFalse:[minZ := v1 rasterPosZ. maxZ := v0 rasterPosZ]].
	].
! !

!B3DPrimitiveFace methodsFor: 'initialize' stamp: 'ar 4/8/1999 04:32'!
initializePass1
	"Assume: v0 sortsBefore: v1 sortsBefore: v2"
	| area majorDz minorDz |
	self initializeDepthBounds. "Compute minZ/maxZ"
	"Compute the major and minor reference edges"
	majorDx := v2 rasterPosX - v0 rasterPosX.
	majorDy := v2 rasterPosY - v0 rasterPosY.
	minorDx := v1 rasterPosX - v0 rasterPosX.
	minorDy := v1 rasterPosY - v0 rasterPosY.

	"Compute the inverse area of the face"
	area := (majorDx * minorDy) - (minorDx * majorDy).
	((area > -0.001) and:[area < 0.001])
		ifTrue:[oneOverArea := 0.0]
		ifFalse:[oneOverArea := 1.0 / area].
	"Compute dzdx and dzdy"
	majorDz := v2 rasterPosZ - v0 rasterPosZ.
	minorDz := v1 rasterPosZ - v0 rasterPosZ.
	dzdx := oneOverArea * ((majorDz * minorDy) - (minorDz * majorDy)).
	dzdy := oneOverArea * ((majorDx * minorDz) - (majorDz * minorDx)).
! !

!B3DPrimitiveFace methodsFor: 'initialize' stamp: 'ar 4/18/1999 06:35'!
initializePass2
	"The receiver is about to be drawn.
	Initialize all the attributes deferred until now."
	| majorDv minorDv dvdx dvdy w0 w1 w2 baseValue rAttr gAttr bAttr aAttr wAttr sAttr tAttr |
	"Red"
	majorDv := v2 redValue - v0 redValue.
	minorDv := v1 redValue - v0 redValue.
	dvdx := oneOverArea * ((majorDv * minorDy) - (minorDv * majorDy)).
	dvdy := oneOverArea * ((majorDx * minorDv) - (majorDv * minorDx)).
	attributes := rAttr := B3DPrimitiveFaceAttributes new.
	rAttr value: v0 redValue; dvdx: dvdx; dvdy: dvdy.
	"Green"
	majorDv := v2 greenValue - v0 greenValue.
	minorDv := v1 greenValue - v0 greenValue.
	dvdx := oneOverArea * ((majorDv * minorDy) - (minorDv * majorDy)).
	dvdy := oneOverArea * ((majorDx * minorDv) - (majorDv * minorDx)).
	gAttr := B3DPrimitiveFaceAttributes new.
	gAttr value: v0 greenValue; dvdx: dvdx; dvdy: dvdy.
	rAttr nextAttr: gAttr.
	"Blue"
	majorDv := v2 blueValue - v0 blueValue.
	minorDv := v1 blueValue - v0 blueValue.
	dvdx := oneOverArea * ((majorDv * minorDy) - (minorDv * majorDy)).
	dvdy := oneOverArea * ((majorDx * minorDv) - (majorDv * minorDx)).
	bAttr := B3DPrimitiveFaceAttributes new.
	bAttr value: v0 blueValue; dvdx: dvdx; dvdy: dvdy.
	gAttr nextAttr: bAttr.
	"Alpha"
	majorDv := v2 alphaValue - v0 alphaValue.
	minorDv := v1 alphaValue - v0 alphaValue.
	dvdx := oneOverArea * ((majorDv * minorDy) - (minorDv * majorDy)).
	dvdy := oneOverArea * ((majorDx * minorDv) - (majorDv * minorDx)).
	aAttr := B3DPrimitiveFaceAttributes new.
	aAttr value: v0 alphaValue; dvdx: dvdx; dvdy: dvdy.
	bAttr nextAttr: aAttr.

	"W part"
	texture == nil ifFalse:[
		w0 := v0 rasterPosW. w1 := v1 rasterPosW. w2 := v2 rasterPosW.
		majorDv := w2 - w0.
		minorDv := w1 - w0.
		dvdx := oneOverArea * ((majorDv * minorDy) - (minorDv * majorDy)).
		dvdy := oneOverArea * ((majorDx * minorDv) - (majorDv * minorDx)).
		wAttr := B3DPrimitiveFaceAttributes new.
		wAttr value: w0; dvdx: dvdx; dvdy: dvdy.
		aAttr nextAttr: wAttr.

		baseValue := v0 texCoordS * w0.
		majorDv := (v2 texCoordS * w2) - baseValue.
		minorDv := (v1 texCoordS * w1) - baseValue.
		dvdx := oneOverArea * ((majorDv * minorDy) - (minorDv * majorDy)).
		dvdy := oneOverArea * ((majorDx * minorDv) - (majorDv * minorDx)).
		sAttr := B3DPrimitiveFaceAttributes new.
		sAttr value: baseValue; dvdx: dvdx; dvdy: dvdy.
		wAttr nextAttr: sAttr.

		baseValue := v0 texCoordT * w0.
		majorDv := (v2 texCoordT * w2) - baseValue.
		minorDv := (v1 texCoordT * w1) - baseValue.
		dvdx := oneOverArea * ((majorDv * minorDy) - (minorDv * majorDy)).
		dvdy := oneOverArea * ((majorDx * minorDv) - (majorDv * minorDx)).
		tAttr := B3DPrimitiveFaceAttributes new.
		tAttr value: baseValue; dvdx: dvdx; dvdy: dvdy.
		sAttr nextAttr: tAttr.
	].! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/5/1999 19:05'!
leftEdge
	^leftEdge! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/5/1999 19:06'!
leftEdge: anEdge
	leftEdge := anEdge! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/5/1999 18:22'!
maxZ
	^maxZ! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/5/1999 18:21'!
minZ
	^minZ! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:33'!
nextFace
	^nextFace! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:34'!
nextFace: aFace
	nextFace := aFace! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/5/1999 19:03'!
oneOverArea
	^oneOverArea! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:33'!
prevFace
	^prevFace! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/3/1999 00:34'!
prevFace: aFace
	prevFace := aFace! !

!B3DPrimitiveFace methodsFor: 'printing' stamp: 'ar 4/5/1999 01:22'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPut:$(;
		print: (v0 windowPos bitShiftPoint:-12);
		nextPutAll:' - ';
		print: (v1 windowPos bitShiftPoint: -12);
		nextPutAll:' - ';
		print: (v2 windowPos bitShiftPoint: -12);
		nextPut:$).! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/5/1999 19:05'!
rightEdge
	^rightEdge! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/5/1999 19:06'!
rightEdge: anEdge
	rightEdge := anEdge! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:20'!
texture
	^texture! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:20'!
texture: aTexture
	texture := aTexture! !

!B3DPrimitiveFace methodsFor: 'initialize' stamp: 'ar 4/4/1999 21:54'!
v0: vtx0 v1: vtx1 v2: vtx2
	v0 := vtx0.
	v1 := vtx1.
	v2 := vtx2.
	flags := 0.! !

!B3DPrimitiveFace methodsFor: 'initialize' stamp: 'ar 4/7/1999 01:01'!
validateDepthSetup
	oneOverArea = 0.0 ifTrue:[^self].
	(v0 rasterPosZ - (self zValueAtX: v0 rasterPosX y: v0 rasterPosY)) abs >= 1.0e-10 
		ifTrue:[self error:'Depth problem'].
	(v1 rasterPosZ - (self zValueAtX: v1 rasterPosX y: v1 rasterPosY)) abs >= 1.0e-10 
		ifTrue:[self error:'Depth problem'].
	(v2 rasterPosZ - (self zValueAtX: v2 rasterPosX y: v2 rasterPosY)) abs >= 1.0e-10 
		ifTrue:[self error:'Depth problem'].! !

!B3DPrimitiveFace methodsFor: 'initialize' stamp: 'ar 4/3/1999 21:24'!
validateVertexOrder
	(v0 sortsBefore: v1) ifFalse:[self error:'Vertex order problem'].
	(v0 sortsBefore: v2) ifFalse:[self error:'Vertex order problem'].
	(v1 sortsBefore: v2) ifFalse:[self error:'Vertex order problem'].! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/3/1999 21:32'!
vertex0
	^v0! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/3/1999 21:32'!
vertex1
	^v1! !

!B3DPrimitiveFace methodsFor: 'accessing' stamp: 'ar 4/3/1999 21:32'!
vertex2
	^v2! !

!B3DPrimitiveFace methodsFor: 'processing' stamp: 'ar 4/8/1999 04:31'!
zValueAtX: xValue y: yValue
	"Return the z value of the receiver at position xValue@yValue"
	^v0 rasterPosZ +
		(yValue - v0 rasterPosY * dzdy) +
		(xValue - v0 rasterPosX * dzdx)! !

Object subclass: #B3DPrimitiveFaceAttributes
	instanceVariableNames: 'nextAttr value dvdx dvdy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins-Simulator'!

!B3DPrimitiveFaceAttributes methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:33'!
dvdx
	^dvdx! !

!B3DPrimitiveFaceAttributes methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:33'!
dvdx: aNumber
	dvdx := aNumber! !

!B3DPrimitiveFaceAttributes methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:33'!
dvdy
	^dvdy! !

!B3DPrimitiveFaceAttributes methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:33'!
dvdy: aNumber
	dvdy := aNumber! !

!B3DPrimitiveFaceAttributes methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:32'!
nextAttr
	^nextAttr! !

!B3DPrimitiveFaceAttributes methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:32'!
nextAttr: attr
	nextAttr := attr.! !

!B3DPrimitiveFaceAttributes methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:32'!
value
	^value! !

!B3DPrimitiveFaceAttributes methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:32'!
value: aNumber
	value := aNumber! !

!B3DPrimitiveFaceAttributes methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:34'!
valueAtX: xValue y: yValue
	"Return the value of the attribute at position xValue@yValue"
	^value + (yValue * dvdy) + (xValue * dvdx)! !

Object subclass: #B3DPrimitiveObject
	instanceVariableNames: 'next prev texture bounds minZ maxZ start faces vertices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Balloon3D-Plugins-Simulator'!

!B3DPrimitiveObject methodsFor: 'streaming' stamp: 'ar 4/18/1999 05:26'!
atEnd
	^start >= faces size! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 05:43'!
bounds
	^bounds! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 04:49'!
faces
	^faces! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 04:49'!
faces: anArray
	faces := anArray! !

!B3DPrimitiveObject methodsFor: 'processing' stamp: 'ar 4/18/1999 05:44'!
mapVertices: viewport
	"Map all the vertices in the receiver"
	| xOfs yOfs xScale yScale w x y z scaledX scaledY first |
	xOfs := (viewport origin x + viewport corner x) * 0.5 - 0.5.
	yOfs := (viewport origin y + viewport corner y) * 0.5 - 0.5.
	xScale := (viewport corner x - viewport origin x) * 0.5.
	yScale := (viewport corner y - viewport origin y) * -0.5.
	bounds := 16r3FFFFFFF asPoint extent: 0@0.
	minZ := maxZ := 0.0.
	first := true.
	vertices do:[:vtx|
		w := vtx rasterPosW.
		w = 0.0 ifFalse:[w := 1.0 / w].
		x := vtx rasterPosX * w * xScale + xOfs.
		y := vtx rasterPosY * w * yScale + yOfs.
		z := vtx rasterPosZ * w.
		vtx rasterPosW: w.
		vtx rasterPosZ: z.
		scaledX := (x * 4096.0) asInteger.
		scaledY := (y * 4096.0) asInteger.
		vtx windowPosX: scaledX.
		vtx windowPosY: scaledY.
		true ifTrue:[
			vtx rasterPosX: scaledX / 4096.0.
			vtx rasterPosY: scaledY / 4096.0.
		] ifFalse:[
			vtx rasterPosX: x.
			vtx rasterPosY: y.
		].
		first ifTrue:[
			bounds := scaledX@scaledY extent: 0@0.
			minZ := maxZ := z.
			first := false.
		] ifFalse:[
			bounds := bounds encompass: scaledX@scaledY.
			minZ := minZ min: z. 
			maxZ := maxZ max: z.
		].
	].
	bounds := (bounds origin bitShiftPoint: -12) corner: (bounds corner bitShiftPoint: -12).! !

!B3DPrimitiveObject methodsFor: 'streaming' stamp: 'ar 4/18/1999 06:55'!
next
	| iFace face |
	iFace := faces at: (start := start + 1).
	face := B3DPrimitiveFace new.
	face 
		v0: (vertices at: iFace p1Index)
		v1: (vertices at: iFace p2Index)
		v2: (vertices at: iFace p3Index).
	face texture: texture.
	face initializePass1.
	B3DScanner doDebug ifTrue:[
		face validateVertexOrder.
		face validateDepthSetup].
	^face! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 05:44'!
nextObj
	^next! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 05:44'!
nextObj: obj
	next := obj! !

!B3DPrimitiveObject methodsFor: 'streaming' stamp: 'ar 4/18/1999 05:25'!
peekY
	^(vertices at: (faces at: start+1) p1Index) windowPosY! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 05:44'!
prevObj
	^prev! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 05:45'!
prevObj: obj
	prev := obj! !

!B3DPrimitiveObject methodsFor: 'initialize' stamp: 'ar 4/18/1999 05:22'!
reset
	start := 0.! !

!B3DPrimitiveObject methodsFor: 'processing' stamp: 'ar 4/18/1999 05:12'!
setupVertexOrder
	faces do:[:face| self setupVertexOrder: face].! !

!B3DPrimitiveObject methodsFor: 'processing' stamp: 'ar 4/18/1999 05:10'!
setupVertexOrder: face
	| p1 p2 i1 i2 i3 p3  |
	i1 := face p1Index.
	i2 := face p2Index.
	i3 := face p3Index.
	p1 := vertices at: i1.
	p2 := vertices at: i2.
	p3 := vertices at: i3.
	(p1 sortsBefore: p2) ifTrue:[
		(p2 sortsBefore: p3) ifTrue:[
			face p1Index: i1; p2Index: i2; p3Index: i3.
		] ifFalse:[
			(p1 sortsBefore: p3)
				ifTrue:[face p1Index: i1; p2Index: i3; p3Index: i2]
				ifFalse:[face p1Index: i3; p2Index: i1; p3Index: i2]
		].
	] ifFalse:[
		(p1 sortsBefore: p3) ifTrue:[
			face p1Index: i2; p2Index: i1; p3Index: i3.
		] ifFalse:[
			(p2 sortsBefore: p3)
				ifTrue:[face p1Index: i2; p2Index: i3; p3Index: i1]
				ifFalse:[face p1Index: i3; p2Index: i2; p3Index: i1]
		]
	].
	B3DScanner doDebug ifTrue:[
		p1 := vertices at: face p1Index.
		p2 := vertices at: face p2Index.
		p3 := vertices at: face p3Index.
		((p1 sortsBefore: p2) and:[(p2 sortsBefore: p3) and:[p1 sortsBefore: p3]])
			ifFalse:[self error:'Vertex order problem'].
	].
! !

!B3DPrimitiveObject methodsFor: 'processing' stamp: 'ar 4/18/1999 05:13'!
sortInitialFaces
	faces := faces sortBy:[:face1 :face2| (vertices at: face1 p1Index) sortsBefore: (vertices at: face2 p1Index)].! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:56'!
texture
	^texture! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 06:56'!
texture: aTexture
	texture := aTexture! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 04:49'!
vertices
	^vertices! !

!B3DPrimitiveObject methodsFor: 'accessing' stamp: 'ar 4/18/1999 04:49'!
vertices: anArray
	vertices := anArray! !

Object subclass: #B3DScanner
	instanceVariableNames: 'aet fillList added lastIntersection nextIntersection objects spanBuffer bitBlt nFaces maxFaces maxEdges'
	classVariableNames: 'DebugMode FlagContinueLeftEdge FlagContinueRightEdge FlagEdgeLeftMajor FlagEdgeRightMajor FlagFaceActive FlagFaceInitialized'
	poolDictionaries: ''
	category: 'Balloon3D-Plugins-Simulator'!

!B3DScanner class methodsFor: 'accessing' stamp: 'ar 4/18/1999 07:24'!
doDebug
	^DebugMode == true! !

!B3DScanner class methodsFor: 'accessing' stamp: 'ar 4/18/1999 07:25'!
doDebug: aBool
	"B3DScanner doDebug: true"
	"B3DScanner doDebug: false"
	DebugMode := aBool.! !

!B3DScanner class methodsFor: 'class initialization' stamp: 'ar 4/8/1999 18:30'!
initialize
	"B3DScanner initialize"
	FlagContinueLeftEdge := 1.
	FlagContinueRightEdge := 2.
	FlagEdgeLeftMajor := 4.
	FlagEdgeRightMajor := 8.
	FlagFaceActive := 1.
	FlagFaceInitialized := 2.! !

!B3DScanner class methodsFor: 'instance creation' stamp: 'ar 3/4/2004 23:00'!
new
	^self basicNew initialize! !

!B3DScanner methodsFor: 'aet adding' stamp: 'ar 4/18/1999 08:14'!
addEdgesFromFace: face at: yValue
	"Add the two top edges from the given face to the aet.
	The top edges are (v0-v1) and (v0-v2) where (v0-v1) is 
	the 'upper' half-edge of the triangle"
	| xValue index needMajor needMinor majorEdge minorEdge |
	face oneOverArea = 0.0 ifTrue:[^self].
	needMinor := needMajor := true. "We need both edges"
	majorEdge := minorEdge := nil.
	xValue := face vertex0 windowPosX.
	"Search the insertion list to merge the edges of the face"
	index := added firstIndexForInserting: xValue.
	index := added xValue: xValue from: index do:[:edge|
		(edge rightFace == nil and:[
			"Note: edge vertex0 == face vertex0 should be the case for most meshes.
				But since it is advantegous for the scanner to have two faces per edge
				we're also checking for the actual vertex values."
			edge vertex0 == face vertex0 or:[
				edge vertex0 rasterPos = face vertex0 rasterPos]]) ifTrue:[
			"This edge is a possible candidate for adding the face"
			(needMajor and:["See above comment"
				edge vertex1 == face vertex2 or:[
					edge vertex1 rasterPos = face vertex2 rasterPos]]) ifTrue:[
				majorEdge := edge.
				edge rightFace: face.
				edge flags: (edge flags bitOr: FlagEdgeRightMajor).
				nFaces := nFaces + 1.
				needMinor ifFalse:[
					^self adjustFace: face major: majorEdge minor: minorEdge]. "Done."
				needMajor := false.
			] ifFalse:[
				(needMinor and:["See above comment"
					edge vertex1 == face vertex1 or:[
						edge vertex1 rasterPos = face vertex1 rasterPos]]) ifTrue:[
					minorEdge := edge.
					edge rightFace: face.
					edge flags: (edge flags bitOr: FlagContinueRightEdge).
					needMajor ifFalse:[
						^self adjustFace: face major: majorEdge minor: minorEdge]. "Done."
					needMinor := false.
				].
			].
		].
	].
	"Need to add new edges.
	NOTE: index already points to the right point for insertion."
	needMajor ifTrue:[
		majorEdge := B3DPrimitiveEdge new.
		majorEdge v0: face vertex0 v1: face vertex2.
		majorEdge nLines = 0 ifTrue:[^self]. "Horizontal edge"
		majorEdge leftFace: face.
		majorEdge initializePass1.
		majorEdge flags: (majorEdge flags bitOr: FlagEdgeLeftMajor).
		nFaces := nFaces + 1.
	].
	needMinor ifTrue:[
		minorEdge := B3DPrimitiveEdge new.
		minorEdge v0: face vertex0 v1: face vertex1.
		minorEdge leftFace: face.
		minorEdge flags: FlagContinueLeftEdge.

		"Note: If the (upper) minor edge is horizontal, use the lower one.
		Note: The lower minor edge cannot be horizontal if the major one isn't"
		minorEdge nLines = 0 ifTrue:[
			needMajor ifTrue:[added add: majorEdge beforeIndex: index].
			minorEdge := self addLowerEdge: minorEdge fromFace: face.
			minorEdge nLines = 0 ifTrue:[self error:'Minor edge is horizontal'].
			^self adjustFace: face major: majorEdge minor: minorEdge].

		minorEdge flags: FlagContinueLeftEdge.
		minorEdge initializePass1.
		minorEdge xValue = xValue ifFalse:[self error:'Problem with minor edge'].
		minorEdge nLines = 0 ifTrue:[self error:'Minor edge is horizontal'].
	].
	needMajor & needMinor ifTrue:[
		added add: majorEdge and: minorEdge beforeIndex: index.
	] ifFalse:[
		needMajor
			ifTrue:[added add: majorEdge beforeIndex: index]
			ifFalse:[added add: minorEdge beforeIndex: index].
	].
	^self adjustFace: face major: majorEdge minor: minorEdge.! !

!B3DScanner methodsFor: 'aet adding' stamp: 'ar 4/18/1999 05:56'!
addLowerEdge: oldEdge fromFace: face
	"Add the lower edge (v1-v2) from the given face.
	Return the newly created edge."
	| index minorEdge xValue |
	xValue := face vertex1 windowPosX.
	index := added firstIndexForInserting: xValue.
	index := added xValue: xValue from: index do:[:edge|
		(edge rightFace == nil and:[
			"See the comment in #addEdgesFromFace:at:"
			(edge vertex0 == face vertex1 and:[edge vertex1 == face vertex2]) or:[
			edge vertex0 rasterPos = face vertex1 rasterPos and:[
				edge vertex1 rasterPos = face vertex2 rasterPos]]]) ifTrue:[
				"Adjust the left or right edge of the face"
				face leftEdge == oldEdge
					ifTrue:[face leftEdge: edge]
					ifFalse:[face rightEdge: edge].
				edge rightFace: face.
				^edge
			].
	].
	"Need to add new edge.
	NOTE: index already points to the right point for insertion."
	minorEdge := B3DPrimitiveEdge new.
	minorEdge v0: face vertex1 v1: face vertex2.
	minorEdge nLines = 0 ifTrue:[^self]. "Horizontal"
	"Adjust left/right edge of the face"
	face leftEdge == oldEdge
		ifTrue:[face leftEdge: minorEdge]
		ifFalse:[face rightEdge: minorEdge].
	minorEdge leftFace: face.
	minorEdge initializePass1.
	added add: minorEdge beforeIndex: index.
	^minorEdge! !

!B3DScanner methodsFor: 'public' stamp: 'ar 4/18/1999 05:15'!
addObject: primObj
	objects add: primObj.! !

!B3DScanner methodsFor: 'aet adding' stamp: 'ar 4/8/1999 03:02'!
adjustFace: face major: majorEdge minor: minorEdge
	"Set the left/right edge of the face to the appropriate edges"
	(majorEdge == nil or:[minorEdge == nil]) 
		ifTrue:[^self error:'Edges must be non-nil'].
	majorEdge xValue = minorEdge xValue ifTrue:[
		"Most likely case. Both edges start at the same point.
		Use dx/dy slope for determining which one is left and which one is right.
		NOTE: 	We have this already computed during face>>initializePass1.
				The value to use is the x increment at each scan line.
		NOTE2: 	There is also a border case when minorEdge is actually the lower
				edge of the triangle. If both xValues are equal, then the triangle
				is degenerate (e.g., it's area is zero) in which case the meaning of
				'left' or 'right' does not matter at all (and can thus be handled
				by this simple test)."
		majorEdge xIncrement <= minorEdge xIncrement
			ifTrue:[	face leftEdge: majorEdge.
					face rightEdge: minorEdge]
			ifFalse:[	face leftEdge: minorEdge.
					face rightEdge: majorEdge].
	] ifFalse:[
		"If the x values are not equal, simply use the edge with the smaller x value as 'left' edge"
		majorEdge xValue < minorEdge xValue 
			ifTrue:[	face leftEdge: majorEdge.
					face rightEdge: minorEdge]
			ifFalse:[	face leftEdge: minorEdge.
					face rightEdge: majorEdge].
	].! !

!B3DScanner methodsFor: 'aet scanning' stamp: 'ar 4/18/1999 05:57'!
adjustIntersectionsAt: yValue from: topEdge
	"The top face has changed. Adjust for possible intersections in the same scan line."
	| frontFace backFace |
	frontFace := fillList first.

	"If frontFace is nil then the fillList is empty.
	If frontFace nextFace is nil then there is only one face in the list."
	(frontFace == nil or:[frontFace nextFace == nil]) ifTrue:[^self].

	"Now, search the fill list until we reach the first face with minZ > face maxZ.
	Note that we have a linked list and can thus start from frontFace nextFace 
	until we reach the end of the face list (nil)."
	backFace := frontFace nextFace.
	[backFace == nil] whileFalse:[
		(self checkIntersectionOf: frontFace with: backFace at: yValue edge: topEdge)
			ifFalse:[^self]. "Aborted."
		backFace := backFace nextFace.
	].! !

!B3DScanner methodsFor: 'public' stamp: 'kfr 6/26/2000 14:50'!
bitBlt
	^bitBlt! !

!B3DScanner methodsFor: 'public' stamp: 'ar 4/18/1999 05:29'!
bitBlt: aBitBlt
	bitBlt := aBitBlt.! !

!B3DScanner methodsFor: 'aet scanning' stamp: 'ar 4/13/1999 01:00'!
checkIntersectionOf: frontFace with: backFace at: yValue edge: leftEdge
	"Compute the possible intersection of frontFace and backFace at the given y value.
	Store the earliest intersection in nextIntersection. Return false if the face enumeration
	should be aborted, true otherwise. leftEdge is the edge defining the left-most boundary
	for possible intersections (e.g., all intersections have to be >= leftEdge xValue)"
	| floatX floatY frontZ backZ xValue rightX |
	backFace minZ >= frontFace maxZ ifTrue:[^false]. "Abort. Everything behind will be further away."
	"Check for shared edge of faces"
	frontFace leftEdge == backFace leftEdge ifTrue:[^true]. "Proceed."
	frontFace rightEdge == backFace rightEdge ifTrue:[^true]. "Proceed."

	"Check for newly created front face"
	(frontFace leftEdge xValue bitShift: -12) = 
		(frontFace rightEdge xValue bitShift: -12) ifTrue:[^false]. "Abort"
	"Check for newly created back face"
	(backFace leftEdge xValue bitShift: -12) = 
		(backFace rightEdge xValue bitShift: -12) ifTrue:[^true]. "Proceed"

	"Compute the z value of either frontFace or backFace depending on whose
	right edge x value is less (so we test a point that is inside both faces)"
	floatY := yValue.
	frontFace rightEdge xValue <= backFace rightEdge xValue ifTrue:[
		"Use frontFace rightEdge as reference value"
		frontZ := frontFace rightEdge zValue.
		rightX := frontFace rightEdge xValue.
		floatX := rightX / 4096.0.
		backZ := backFace zValueAtX: floatX y: floatY.
	] ifFalse:[
		"Use backFace rightEdge as reference value"
		backZ := backFace rightEdge zValue.
		rightX := backFace rightEdge xValue.
		floatX := rightX / 4096.0.
		frontZ := frontFace zValueAtX: floatX y: floatY.
	].
	backZ < frontZ ifTrue:[
		"Found a possible intersection."
		xValue := self computeIntersectionOf: frontFace with: backFace at: yValue ifError: leftEdge xValue.
		"The following tests for numerical inaccuracies"
		xValue > rightX ifTrue:[xValue := rightX].
		xValue < leftEdge xValue ifTrue:[
			"In theory, this cannot happen. We may, however, have slight
			numerical inaccuracies here, too. Conceptually, we treat these
			intersections as if they occured immediately at the same 
			fractional pixel in the scan line."
			xValue := leftEdge xValue].
		(xValue bitShift: -12) = (leftEdge xValue bitShift: -12) ifTrue:[
			"Intersections at the same pixel are ignored. Process it at the next pixel.
			NOTE: This step is incredibly important!! It is by ignoring intersections
			at the same pixel that we can never run in an endless repetition of
			intersections at the same pixel value."
			xValue := (leftEdge xValue bitShift: -12) + 1 bitShift: 12.
		].
		xValue < nextIntersection xValue ifTrue:[
			nextIntersection xValue: xValue.
			nextIntersection leftFace: frontFace.
			nextIntersection rightFace: backFace.
		].
	].
	^true "proceed"! !

!B3DScanner methodsFor: 'span drawing' stamp: 'ar 4/18/1999 05:45'!
clearSpanBufferAt: yValue
	spanBuffer primFill: 0.! !

!B3DScanner methodsFor: 'aet scanning' stamp: 'ar 4/8/1999 03:14'!
computeIntersectionOf: frontFace with: backFace at: yValue ifError: errorValue
	"Compute the z intersection at the given y value"
	| dx1 dz1 dx2 dz2 px pz det det2 |
	dx1 := frontFace rightEdge xValue - frontFace leftEdge xValue.
	dz1 := frontFace rightEdge zValue - frontFace leftEdge zValue.
	dx2 := backFace rightEdge xValue - backFace leftEdge xValue.
	dz2 := backFace rightEdge zValue - backFace leftEdge zValue.
	px := backFace leftEdge xValue - frontFace leftEdge xValue.
	pz := backFace leftEdge zValue - frontFace leftEdge zValue.
	"Solve the linear equation using cramers rule"
	det := (dx1 * dz2) - (dx2 * dz1).
	det = 0.0 ifTrue:[^errorValue].
	"det1 := (dx1 * pz) - (px * dz1)."
	det2 := (px * dz2) - (pz * dx2).
	"det1 := det1 / det."
	det2 := det2 / det.
	^frontFace leftEdge xValue + (dx1 * det2) truncated! !

!B3DScanner methodsFor: 'span drawing' stamp: 'ar 4/18/1999 06:46'!
drawSpanBufferAt: yValue
	| leftX rightX |
	leftX := aet first xValue bitShift: -12.
	rightX := aet last xValue bitShift: -12.
	bitBlt copyBitsFrom: leftX to: rightX at: yValue.! !

!B3DScanner methodsFor: 'span drawing' stamp: 'ar 4/18/1999 06:55'!
fillFrom: leftEdge to: rightEdge at: yValue
	| face |
	leftEdge xValue >= rightEdge xValue ifTrue:[^self]. "Nothing to do"
	face := fillList first.
	face == nil ifTrue:[^self].
	face texture == nil
		ifTrue:[self rgbFill: face from: leftEdge to: rightEdge at: yValue]
		ifFalse:[self rgbstwFill: face from: leftEdge to: rightEdge at: yValue]! !

!B3DScanner methodsFor: 'initialize' stamp: 'ar 4/18/1999 07:59'!
initialize
	aet := B3DActiveEdgeTable new.
	fillList := B3DFillList new.
	added := B3DPrimitiveEdgeList new.
	lastIntersection := B3DPrimitiveEdge new.
	nextIntersection := B3DPrimitiveEdge new.
	objects := OrderedCollection new.! !

!B3DScanner methodsFor: 'aet scanning' stamp: 'ar 4/8/1999 03:15'!
isOnTop: edge at: yValue
	"Return true if the edge is on top of the current front face"
	| topFace floatX floatY |
	topFace := fillList first.
	topFace == nil ifTrue:[^true].
	"Note: It is important to return true if the edge is shared by the top face"
	(edge leftFace == topFace or:[edge rightFace == topFace]) ifTrue:[^true].
	floatX := edge xValue / 4096.0.
	floatY := yValue.
	^edge zValue < (fillList first zValueAtX: floatX y:  floatY).! !

!B3DScanner methodsFor: 'public' stamp: 'ar 4/18/1999 07:55'!
mainLoop
	| yValue nextObjY nextEdgeY obj activeStart passiveStart scaledY |
	objects size = 0 ifTrue:[^self]. "No input"
	self setupObjects. "Sort objects and create linked list"
	nFaces := maxFaces := maxEdges := 0.
	"Pre-fetch first object to start from"
	activeStart := passiveStart := objects at: 1.
	yValue := nextEdgeY := nextObjY := passiveStart bounds origin y.
	[activeStart == nil and:[passiveStart == nil and:[aet isEmpty]]] whileFalse:[
		"Add new objects if necessary"
		yValue = nextObjY ifTrue:[
			"Make sure we add edges from newly created objects"
			nextEdgeY := nextObjY.
			"Add new objects"
			[passiveStart notNil and:[passiveStart bounds origin y = nextObjY]]
				whileTrue:[passiveStart := passiveStart nextObj].
			passiveStart == nil 
				ifTrue:[nextObjY := 99999]"Some large value"
				ifFalse:[nextObjY := passiveStart bounds origin y]. 
		]. "End of adding new objects"

		"Add new edges if necessary"
		yValue = nextEdgeY ifTrue:[
			nextEdgeY := nextObjY bitShift: 12. "Some VERY large value"
			scaledY := (yValue+1) bitShift: 12.
			obj := activeStart.
			[obj == passiveStart] whileFalse:[
				[obj atEnd not and:[obj peekY < scaledY]]
					whileTrue:[self addEdgesFromFace: obj next at: yValue].
				obj atEnd ifTrue:[
					obj == activeStart
						ifTrue:[activeStart := obj nextObj]
						ifFalse:[obj prevObj nextObj: obj nextObj].
				] ifFalse:[obj peekY < nextEdgeY ifTrue:[nextEdgeY := obj peekY]].
				obj := obj nextObj.
			].
			nextEdgeY := (nextEdgeY bitShift: -12).
		].
		added isEmpty ifFalse:[
			"Merge new edges into AET"
			"Note: These may be lower half edges."
			B3DScanner doDebug ifTrue:[self validateAETOrder].
			aet mergeEdgesFrom: added.
			B3DScanner doDebug ifTrue:[
				self validateAETOrder.
				self validateEdgesFrom: aet].
			added reset. "Clean up the list"
		].

		"This is the core loop."
		"[yValue < nextEdgeY and:[added isEmpty and:[aet isEmpty not]]] whileTrue:["
			B3DScanner doDebug ifTrue:[yValue printString displayAt: 0@0].
			"gather stats"
			maxEdges := maxEdges max: aet size.
			maxFaces := maxFaces max: nFaces.

			"Scan out the AET"
			aet isEmpty ifFalse:[
				self clearSpanBufferAt: yValue.
				self scanAETAt: yValue.
				self drawSpanBufferAt: yValue.

				"Advance to next y and update AET"
			].
			yValue := yValue + 1.
			aet isEmpty ifFalse:[self updateAETAt: yValue].
		"]."
	].
	nFaces = 0 ifFalse:[self error: nFaces printString,' remaining faces'].! !

!B3DScanner methodsFor: 'public' stamp: 'ar 4/18/1999 05:31'!
resetObjects
	objects := OrderedCollection new.! !

!B3DScanner methodsFor: 'span drawing' stamp: 'ar 4/18/1999 06:48'!
rgbFill: face from: leftEdge to: rightEdge at: yValue
	"Using only RGB (no alpha no textures)"
	| leftX rightX floatY floatX rValue gValue bValue pv rAttr gAttr bAttr |
	"Note: We always sample at pixel centers.
	If the edges do not include this pixel center, do nothing.
	Otherwise fill from leftX to rightX, including both pixels."
	leftX := (leftEdge xValue bitShift: -12) + 1.
	rightX := rightEdge xValue bitShift: -12.
	leftX < 0 ifTrue:[leftX := 0].
	rightX >= spanBuffer size ifTrue:[rightX := spanBuffer size-1].
	leftX > rightX ifTrue:[^self].

	B3DScanner doDebug ifTrue:[
		"Sanity check."
		(face leftEdge xValue > leftEdge xValue)
			ifTrue:[
				(face rightEdge xValue < rightEdge xValue)
					ifTrue:[self error:'Filling outside face']
					ifFalse:[self error:'Filling left of face'].
		] ifFalse:[(face rightEdge xValue < rightEdge xValue)
						ifTrue:[self error:'Filling right of face']].
	].

	(face flags anyMask: FlagFaceInitialized) ifFalse:[
		face initializePass2.
		face flags: (face flags bitOr: FlagFaceInitialized)].

	"@@: Sampling problem!!"
	floatY := yValue + 0.5.
	floatX := leftX.

	rAttr := face attributes.
	gAttr := rAttr nextAttr.
	bAttr := gAttr nextAttr.

	rValue := (face attrValue: rAttr atX: floatX y: floatY).
	gValue := (face attrValue: gAttr atX: floatX y: floatY).
	bValue := (face attrValue: bAttr atX: floatX y: floatY).

	[leftX <= rightX] whileTrue:[
		rValue := rValue min: 255.0 max: 0.0.
		gValue := gValue min: 255.0 max: 0.0.
		bValue := bValue min: 255.0 max: 0.0.

		pv := (bValue truncated) +
				(gValue truncated bitShift: 8) +
					(rValue truncated bitShift: 16).
		spanBuffer at: (leftX := leftX+1) put: (pv bitOr: 4278190080).
		rValue := rValue + rAttr dvdx.
		gValue := gValue + gAttr dvdx.
		bValue := bValue + bAttr dvdx].
! !

!B3DScanner methodsFor: 'span drawing' stamp: 'ar 4/18/1999 07:22'!
rgbstwFill: face from: leftEdge to: rightEdge at: yValue
	"Using only RGB & STW (no alpha)"
	| leftX rightX floatY floatX rValue gValue bValue pv rAttr gAttr bAttr aAttr wAttr sAttr tAttr wValue sValue tValue texColor |
	"Note: We always sample at pixel centers.
	If the edges do not include this pixel center, do nothing.
	Otherwise fill from leftX to rightX, including both pixels."
	leftX := (leftEdge xValue bitShift: -12) + 1.
	rightX := rightEdge xValue bitShift: -12.
	leftX < 0 ifTrue:[leftX := 0].
	rightX >= spanBuffer size ifTrue:[rightX := spanBuffer size-1].
	leftX > rightX ifTrue:[^self].
	B3DScanner doDebug ifTrue:[
		"Sanity check."
		(face leftEdge xValue > leftEdge xValue)
			ifTrue:[
				(face rightEdge xValue < rightEdge xValue)
					ifTrue:[self error:'Filling outside face']
					ifFalse:[self error:'Filling left of face'].
		] ifFalse:[(face rightEdge xValue < rightEdge xValue)
						ifTrue:[self error:'Filling right of face']].
	].

	(face flags anyMask: FlagFaceInitialized) ifFalse:[
		face initializePass2.
		face flags: (face flags bitOr: FlagFaceInitialized)].

	"@@: Sampling problem!!"
	floatY := yValue + 0.5.
	floatX := leftX.

	rAttr := face attributes.
	gAttr := rAttr nextAttr.
	bAttr := gAttr nextAttr.
	aAttr := bAttr nextAttr.
	wAttr := aAttr nextAttr.
	sAttr := wAttr nextAttr.
	tAttr := sAttr nextAttr.

	rValue := (face attrValue: rAttr atX: floatX y: floatY).
	gValue := (face attrValue: gAttr atX: floatX y: floatY).
	bValue := (face attrValue: bAttr atX: floatX y: floatY).
	wValue := (face attrValue: wAttr atX: floatX y: floatY).
	sValue := (face attrValue: sAttr atX: floatX y: floatY).
	tValue := (face attrValue: tAttr atX: floatX y: floatY).

	[leftX <= rightX] whileTrue:[
		rValue := rValue min: 255.0 max: 0.0.
		gValue := gValue min: 255.0 max: 0.0.
		bValue := bValue min: 255.0 max: 0.0.

		texColor := self textureColor: face texture atS: (sValue / wValue) atT: (tValue / wValue).

		pv := (bValue * texColor blue) truncated +
				((gValue * texColor green) truncated bitShift: 8) +
					((rValue * texColor red) truncated bitShift: 16).
		spanBuffer at: (leftX := leftX+1) put: (pv bitOr: 4278190080).
		rValue := rValue + rAttr dvdx.
		gValue := gValue + gAttr dvdx.
		bValue := bValue + bAttr dvdx.
		wValue := wValue + wAttr dvdx.
		sValue := sValue + sAttr dvdx.
		tValue := tValue + tAttr dvdx].! !

!B3DScanner methodsFor: 'aet scanning' stamp: 'ar 4/18/1999 07:23'!
scanAETAt: yValue
	"Scan out and draw the active edge table"
	| leftEdge rightEdge tmp |
	aet reset.
	aet atEnd ifTrue:[^nil].

	"Note the following is debug code that allows restarting this method
	without getting confused by the face flags. In release mode, having
	faces in the fillList here would be either an error or due to clipping
	at the right boundary."
	fillList do:[:face| face flags: (face flags bitXor: FlagFaceActive)].
	fillList reset.

	nextIntersection xValue: 16r3FFFFFFF. "Out of reach"
	leftEdge := aet next.
	"No do the AET scan"
	[aet atEnd] whileFalse:[
		"The left edge here is always a top edge. Toggle its fills."
		self toggleTopFillsOf: leftEdge at: yValue.
		"After we got a new top face we have to adjust possible intersections."
		self adjustIntersectionsAt: yValue from: leftEdge. 
		"Search for the next top edge, which will be the right boundary."
		rightEdge := self searchForNewTopEdgeFrom: leftEdge at: yValue.
		"And fill the stuff"
		self fillFrom: leftEdge to: rightEdge at: yValue.

		leftEdge := rightEdge.
		"Use a new intersection edge if necessary"
		leftEdge == nextIntersection ifTrue:[
			tmp := nextIntersection.
			nextIntersection := lastIntersection.
			lastIntersection := tmp].
		nextIntersection xValue: 16r3FFFFFFF "Must be waaaay off to the right ;-)"
	].
	self toggleBackFillsOf: leftEdge at: yValue validate: false.
	fillList isEmpty ifFalse:[self error:'FillList not empty'].! !

!B3DScanner methodsFor: 'aet scanning' stamp: 'ar 4/18/1999 05:59'!
searchForNewTopEdgeFrom: leftEdge at: yValue
	"Find the next top edge in the AET. 
	Note: We have to make sure that intersection edges are returned appropriately."
	| edge topFace |
	topFace := fillList first.
	topFace == nil ifTrue:[^aet next]. "Next edge must be top"
	[aet atEnd] whileFalse:[
		"Check if we have an intersection first."
		nextIntersection xValue <= aet peek xValue ifTrue:[^nextIntersection].
		edge := aet next.
		"Check if the edge is on top"
		(self isOnTop: edge at: yValue) ifTrue:[^edge].
		"If the edge is not on top, toggle the (back) fills of it"
		self toggleBackFillsOf: edge at: yValue validate: true.
	].
	^nil! !

!B3DScanner methodsFor: 'initialize' stamp: 'ar 4/18/1999 05:21'!
setupObjects
	"Set up the list of objects (e.g., triangle inputs)
	by creating a linked list of objects which is sorted by the initial
	yValue of the tris."
	| lastObj |
	objects := objects sortBy: [:obj1 :obj2| obj1 bounds origin sortsBefore: obj2 bounds origin].
	lastObj := nil.
	objects do:[:nextObj|
		nextObj reset.
		nextObj prevObj: lastObj.
		lastObj == nil ifFalse:[lastObj nextObj: nextObj].
		lastObj := nextObj.
	].
	lastObj == nil ifFalse:[lastObj nextObj: nil].
! !

!B3DScanner methodsFor: 'public' stamp: 'ar 4/18/1999 05:28'!
spanBuffer: aBitmap
	spanBuffer := aBitmap.! !

!B3DScanner methodsFor: 'span drawing' stamp: 'ar 5/28/2000 12:19'!
textureColor: aTexture atS: sValue atT: tValue
	"Return the interpolated color of the given texture at s/t"
	| w h fragS fragT sIndex tIndex peeker tex00 tex01 tex10 tex11 sFrac tFrac mixed |
	w := aTexture width.
	h := aTexture height.
	fragS := w * sValue.
	fragT := h * tValue.
	sIndex := fragS truncated.
	tIndex := fragT truncated.
	peeker := BitBlt current bitPeekerFromForm: aTexture.
	tex00 := (peeker pixelAt: (sIndex \\ w)@(tIndex \\ h)) asColorOfDepth: aTexture depth.
	tex01 := (peeker pixelAt: (sIndex+1 \\ w)@(tIndex \\ h)) asColorOfDepth: aTexture depth.
	tex10 := (peeker pixelAt: (sIndex \\ w)@(tIndex+1 \\ h)) asColorOfDepth: aTexture depth.
	tex11 := (peeker pixelAt: (sIndex+1 \\ w)@(tIndex+1 \\ h)) asColorOfDepth: aTexture depth.
	sFrac := fragS \\ 1.0.
	tFrac := fragT \\ 1.0.
	mixed := ((1.0 - tFrac) * (((1.0 - sFrac) * tex00 asB3DColor) + (sFrac * tex01 asB3DColor))) +
			(tFrac * (((1.0 - sFrac) * tex10 asB3DColor) + (sFrac * tex11 asB3DColor))).
	^mixed! !

!B3DScanner methodsFor: 'aet scanning' stamp: 'ar 4/7/1999 04:40'!
toggleBackFillsOf: edge at: yValue validate: aBool
	"Toggle the faces of the (back) edge"
	| face |
	face := edge leftFace.
	(face flags anyMask: FlagFaceActive)
		ifTrue:[	(aBool and:[face == fillList first]) ifTrue:[self error:'Not a back face'].
				fillList remove: face]
		ifFalse:[	fillList addBack: face.
				"Check for possible intersections of back and front face"
				self checkIntersectionOf: fillList first
					with: face at: yValue edge: edge].
	face flags: (face flags bitXor: FlagFaceActive).
	face := edge rightFace.
	face == nil ifTrue:[^self].
	(face flags anyMask: FlagFaceActive)
		ifTrue:[	(aBool and:[face == fillList first]) ifTrue:[self error:'Not a back face'].
				fillList remove: face]
		ifFalse:[	fillList addBack: face.
				"Check for possible intersections of back and front face"
				self checkIntersectionOf: fillList first
					with: face at: yValue edge: edge].
	face flags: (face flags bitXor: FlagFaceActive).
! !

!B3DScanner methodsFor: 'aet scanning' stamp: 'ar 4/5/1999 23:44'!
toggleIntersectionEdge: edge
	"Toggle the faces of the given intersection edge.
	This is a *very* special case."
	fillList first == edge leftFace ifFalse:[^self error:'Left face of intersection edge not top face'].
	fillList remove: edge rightFace.
	fillList addFront: edge rightFace. ! !

!B3DScanner methodsFor: 'aet scanning' stamp: 'ar 4/18/1999 06:01'!
toggleTopFillsOf: edge at: yValue
	"Toggle the faces of the (new top) edge.
	We must carefully treat each of the following cases:
		1) rightFace notNil (e.g., two faces)
			a) rightFace active ~= leftFace active
				=> simply swap leftFace and rightFace in the face list
			b) rightFace active not & leftFace active not
				=> edge defines new boundary entry; check for minimal dxdz and insert in order
			c) rightFace active & leftFace active
				=> edge defines boundary exit; search all faces for minimal z value
		2) rightFace isNil (e.g., single face)
			a) leftFace active
				=> edge defines boundary exit; see 1c)
			b) leftFace active not
				=> edge defines boundary entry; simply put it on top.
	"
	| leftFace rightFace xorMask noTest |
	edge == lastIntersection 
		ifTrue:[^self toggleIntersectionEdge: edge].
	noTest := true.
	leftFace := edge leftFace.
	rightFace := edge rightFace.
	rightFace == nil ifTrue:[
		(leftFace flags anyMask: FlagFaceActive)
			ifTrue:[	leftFace == fillList first | noTest ifFalse:[self error:'Oops'].
					fillList remove: leftFace.
					fillList searchForNewTopAtX: edge xValue y: yValue]
			ifFalse:[	fillList addFront: leftFace].
		leftFace flags: (leftFace flags bitXor: FlagFaceActive).
		^self].
	"rightFace notNil"
	xorMask := leftFace flags bitXor: rightFace flags.
	(xorMask anyMask: FlagFaceActive) ifTrue:[
		"Simply swap"
		(leftFace flags anyMask: FlagFaceActive)
			ifTrue:[	leftFace == fillList first | noTest ifFalse:[self error:'Oops'].
					fillList remove: leftFace.
					fillList addFront: rightFace]
			ifFalse:[	rightFace == fillList first | noTest ifFalse:[self error:'Oops'].
					fillList remove: rightFace.
					fillList addFront: leftFace].
	] ifFalse:["rightFace active = leftFace active"
		(leftFace flags anyMask: FlagFaceActive) ifTrue:[
			(leftFace == fillList or:[rightFace == fillList first]) | noTest ifFalse:[self error:'Oops'].
			fillList remove: leftFace.
			fillList remove: rightFace.
			fillList searchForNewTopAtX: edge xValue y: yValue.
		] ifFalse:[
			leftFace dzdx <= rightFace dzdx
				ifTrue:[	fillList addFront: leftFace.
						fillList addBack: rightFace]
				ifFalse:[	fillList addFront: rightFace.
						fillList addBack: leftFace].
		].
	].
	leftFace flags: (leftFace flags bitXor: FlagFaceActive).
	rightFace flags: (rightFace flags bitXor: FlagFaceActive).
! !

!B3DScanner methodsFor: 'aet updating' stamp: 'ar 4/18/1999 06:02'!
updateAETAt: yValue
	"Advance all entries in the AET by one scan line step"
	| edge count |
	aet reset.
	[aet atEnd] whileFalse:[
		edge := aet next.
		count := edge nLines - 1.
		count = 0 ifTrue:[
			"Remove the edge from the AET.
			If the continuation flag is set, create new (lower) edge(s)."
			(edge vertex1 windowPosY bitShift: -12) = yValue
				ifFalse:[self error:'Edge exceeds range'].
			aet removeFirst.
			(edge flags anyMask: FlagContinueLeftEdge)
				ifTrue:[self addLowerEdge: edge fromFace: edge leftFace].
			(edge flags anyMask: FlagContinueRightEdge) 
				ifTrue:[self addLowerEdge: edge fromFace: edge rightFace].
			(edge flags anyMask: FlagEdgeLeftMajor)
				ifTrue:[nFaces := nFaces - 1].
			(edge flags anyMask: FlagEdgeRightMajor)
				ifTrue:[nFaces := nFaces - 1].
		] ifFalse:[
			"Edge continues. Adjust the number of scan lines remaining
			and update the incremental values. Make sure that the sorting
			order of the AET is not getting confused."
			edge nLines: count. "# of scan lines"
			edge stepToNextLine. "update incremental values"
			aet resortFirst. "make sure edge is sorted right"
		].
	].
! !

!B3DScanner methodsFor: 'misc' stamp: 'ar 4/6/1999 03:49'!
validateAETOrder
	| last next |
	aet isEmpty ifTrue:[^self].
	aet reset.
	last := aet next.
	[aet atEnd] whileFalse:[
		next := aet next.
		last xValue <= next xValue ifFalse:[^self error:'AET is broken'].
		last := next].! !

!B3DScanner methodsFor: 'misc' stamp: 'ar 4/7/1999 05:20'!
validateEdgesFrom: aCollection
	"aCollection must contain two entries for each face."
	| faceNum face faces |
	faceNum := 0.
	aCollection do:[:edge|
		edge leftFace ifNil:[self error:'Bad edge'] ifNotNil:[faceNum := faceNum + 1].
		edge rightFace ifNotNil:[faceNum := faceNum + 1].
	].
	faceNum \\ 2 = 0 ifTrue:[^self].
	faces := Bag new.
	aCollection do:[:edge|
		face := edge leftFace.
		faces add: face.
		(aet indexOf: face leftEdge) = 0 ifTrue:[self error:'Left edge not in AET'].
		(aet indexOf: face rightEdge) = 0 ifTrue:[self error:'Right edge not in AET'].
		face := edge rightFace.
		face == nil ifFalse:[
			faces add: face.
			(aet indexOf: face leftEdge) = 0 ifTrue:[self error:'Left edge not in AET'].
			(aet indexOf: face rightEdge) = 0 ifTrue:[self error:'Right edge not in AET'].
		].
	].
	self error:'Something *IS* wrong here'.! !
B3DScanner initialize!
